package auxiliary_folder_handling;

import gui.active_learning_tool.Active_learning_tool_gui_manager;
import gui.active_learning_tool.Active_learning_tool_loading_bar;
import java.io.*;
import java.util.*;
import javax.swing.*;
import document.*;

public class Auxiliary_creator extends SwingWorker<Void, Void>
{

	public Auxiliary_creator()
	{
		file_separator = System.getProperty("file.separator");
		file_separator = (file_separator.equals("\\"))?"\\\\":file_separator;
	}
	
	//sets the parameters
	public void create_auxiliary(Active_learning_tool_gui_manager m, boolean e_p_d, boolean b_t, boolean g_r, int k_in, boolean o,
			String t_p, String a_p,
			Active_learning_tool_loading_bar b)
	{
		entropy_plus_diversity = e_p_d;
		basic_tagset = b_t;
		gain_ratio = g_r;
		k = k_in;
		overlap = o;
		texts_path = t_p;
		auxiliary_path = a_p;
		bar = b;
		manager = m;
	}
	
	//creates the auxiliary folder
	public Void doInBackground()
	{
		//create a different document file for each text file
		File[] texts = new File(texts_path).listFiles();
		//update the bar message
		bar.progress.setString("Creating Document Files");
		bar.progress.setMaximum(texts.length-1);
		ObjectOutputStream output = null;
		try
		{
			Document_splitter splitter = new Document_splitter();
			//for each text create a different document
			for(int i=0; i<texts.length; ++i)
			{
				bar.progress.setValue(i);
				//create a writer
				output = new ObjectOutputStream(new FileOutputStream(new File(auxiliary_path+
						"" + file_separator + ""+texts[i].getName().substring(0, texts[i].getName().length()-3)+"document")));
				//and print it in the auxiliary folder
				output.writeObject(splitter.get_token_document_for_file(texts[i]));
			}
		}
		catch(IOException ioe)
		{
			JOptionPane.showMessageDialog(null, "Problem occured in the creation of the auxiliary folder");
			System.exit(1);
		}
		finally
		{
			try{output.close();}catch(Exception e){e.printStackTrace();}
			texts = null;
		}
		
		//keep the documents
		File[] documents = new File(auxiliary_path).listFiles();
		calculate_number_of_appearances(documents);
		
		//create the parameters file
		PrintWriter writer = null;
		try
		{
			writer = new PrintWriter(auxiliary_path+"" + file_separator + "parameters.txt", "UTF-8");
			if(entropy_plus_diversity)
			{
				writer.println("true");
			}
			else
			{
				writer.println("false");
			}
			if(basic_tagset)
			{
				writer.println("true");
			}
			else
			{
				writer.println("false");
			}
			if(gain_ratio)
			{
				writer.println("true");
			}
			else
			{
				writer.println("false");
			}
			writer.println(k+"");
			if(overlap)
			{
				writer.print("true");
			}
			else
			{
				writer.print("false");
			}
			writer.flush();
		}
		catch(Exception e)
		{
			e.printStackTrace();
			JOptionPane.showMessageDialog(null, "Problem occured in the creation of the auxiliary folder");
			System.exit(1);
		}
		
		//create the train file
		try
		{
			writer = new PrintWriter(auxiliary_path+"" + file_separator + "train.train", "UTF-8");
		}
		catch(Exception e)
		{
			e.printStackTrace();
			JOptionPane.showMessageDialog(null, "Problem occured in the creation of the auxiliary folder");
			System.exit(1);
		}
		
		//create the current_line file
		try
		{
			writer = new PrintWriter(auxiliary_path+"" + file_separator + "current_line.txt", "UTF-8");
			writer.println("1");
			writer.flush();
		}
		catch(Exception e)
		{
			e.printStackTrace();
			JOptionPane.showMessageDialog(null, "Problem occured in the creation of the auxiliary folder");
			System.exit(1);
		}
		
		
		//create the pool file
		try
		{
			writer = new PrintWriter(auxiliary_path+"" + file_separator + "pool.txt", "UTF-8");
		}
		catch(Exception e)
		{
			e.printStackTrace();
			JOptionPane.showMessageDialog(null, "Problem occured in the creation of the auxiliary folder");
			System.exit(1);
		}
		
		//fill the pool file
		bar.progress.setString("Creating Pool File");
		bar.progress.setMaximum(documents.length-1);
		ObjectInputStream input = null;
		Token_document current_document = null;
		Token_sentence current_sentence = null;
		//for each document
		for(int i=0; i<documents.length; ++i)
		{
			bar.progress.setValue(i);
			try
			{
				input = new ObjectInputStream(new FileInputStream(documents[i]));
				current_document = (Token_document)input.readObject();
				current_sentence = current_document.get_first_sentence();
				//for each sentence in the document
				while(current_sentence != null)
				{
					Token current_token = current_sentence.get_first_token();
					Token last = current_sentence.get_last_token();
					//for each token in the sentence
					while(current_token != last)
					{
						Token previous = current_document.get_previous_token(current_token);
						Token preprevious = current_document.get_previous_token(previous);
						Token next = current_document.get_next_token(current_token);
						if(preprevious == previous)
						{
							preprevious = null;
						}
						if(previous == current_token)
						{
							previous = null;
						}
						if(next == current_token)
						{
							next = null;
						}
						//write the token in the pool file
						writer.print("false ");
						writer.print(token_times.get(current_token.get_token()) + " ");
						writer.print((preprevious == null)?"null ":preprevious.get_token() + " ");
						writer.print((previous == null)?"null ":previous.get_token() + " ");
						writer.print(current_token.get_token() + " ");
						writer.print((next == null)?"null ":next.get_token() + " ");
						writer.print(documents[i].getName() + " ");
						writer.println(current_token.get_starting_position());
						current_token = current_document.get_next_token(current_token);
					}
					//also, print the last token
					Token previous = current_document.get_previous_token(current_token);
					Token preprevious = current_document.get_previous_token(previous);
					Token next = current_document.get_next_token(current_token);
					if(preprevious == previous)
					{
						preprevious = null;
					}
					if(previous == current_token)
					{
						previous = null;
					}
					if(next == current_token)
					{
						next = null;
					}
					writer.print("false ");
					writer.print(token_times.get(current_token.get_token()) + " ");
					writer.print((preprevious == null)?"null ":preprevious.get_token() + " ");
					writer.print((previous == null)?"null ":previous.get_token() + " ");
					writer.print(current_token.get_token() + " ");
					writer.print((next == null)?"null ":next.get_token() + " ");
					writer.print(documents[i].getName() + " ");
					writer.println(current_token.get_starting_position());
					current_sentence = current_document.get_next_sentence(current_sentence);
				}
				writer.flush();
			}
			catch(Exception e)
			{
				e.printStackTrace();
				JOptionPane.showMessageDialog(null, "Problem occured in the creation of the auxiliary folder");
				System.exit(1);
			}
		}
		return null;
	}
	
	//invoked when the doInBackground method is over
	public void done()
	{
		bar.dispose();
		manager.start_proposing(auxiliary_path);
	}
	
	//calculates the times a token appears in the given documents
	private void calculate_number_of_appearances(File[] documents)
	{
		bar.progress.setString("Parsing Tokens");
		bar.progress.setMaximum(documents.length-1);
		token_times = new TreeMap<String, Integer>();
		ObjectInputStream input = null;
		Token_document current_document = null;
		Token_sentence current_sentence = null;
		try
		{
			//for each document
			for(int i=0; i<documents.length; ++i)
			{
				bar.progress.setValue(i);
				input = new ObjectInputStream(new FileInputStream(documents[i]));
				current_document = (Token_document)input.readObject();
				current_sentence = current_document.get_first_sentence();
				//for each sentence in the document
				while(current_sentence != null)
				{
					Token current_token = current_sentence.get_first_token();
					Token last = current_sentence.get_last_token();
					//for each token in the sentence
					while(current_token != last)
					{
						//add one to the number of its appearances
						if(token_times.get(current_token.get_token()) == null)
						{
							token_times.put(current_token.get_token(), new Integer(1));
						}
						else
						{
							token_times.put(current_token.get_token(),
									new Integer(token_times.get(current_token.get_token()).intValue()+1));
						}
						current_token = current_document.get_next_token(current_token);
					}
					//also, for the last token of the sentence
					if(token_times.get(current_token.get_token()) == null)
					{
						token_times.put(current_token.get_token(), new Integer(1));
					}
					else
					{
						token_times.put(current_token.get_token(),
								new Integer(token_times.get(current_token.get_token()).intValue()+1));
					}
					current_sentence = current_document.get_next_sentence(current_sentence);
				}
			}
		}
		catch(Exception e)
		{
			e.printStackTrace();
			JOptionPane.showMessageDialog(null, "Problem occured in the creation of the auxiliary folder");
			System.exit(1);
		}
		finally
		{
			try{input.close();}catch(Exception e){e.printStackTrace();}
		}
	}
	
	private TreeMap<String, Integer> token_times;
	private String texts_path;
	private String auxiliary_path;
	private Active_learning_tool_loading_bar bar;
	private boolean entropy_plus_diversity;
	private boolean basic_tagset;
	private boolean gain_ratio;
	private int k;
	private boolean overlap;
	private Active_learning_tool_gui_manager manager;
	public static String file_separator;
	
}













