package classifier;

import java.io.*;

public class Instance implements Serializable
{

	public Instance()
	{
		
	}
	
	public Instance(Instance in)
	{
		ending = in.get_property_value(0);
		length = Byte.parseByte(in.get_property_value(1));
		has_apostrophe = (in.get_property_value(2).equals("0"))?false:true;
		has_digit = (in.get_property_value(3).equals("0"))?false:true;
		has_dot = (in.get_property_value(4).equals("0"))?false:true;
		has_comma = (in.get_property_value(5).equals("0"))?false:true;
		has_latin_character = (in.get_property_value(6).equals("0"))?false:true;
		ambitag = in.get_property_value(7);
		next_ending = in.get_property_value(8);
		next_ambitag = in.get_property_value(9);
		before_previous = in.get_property_value(10);
		before_previous_ending = in.get_property_value(11);
		previous_ending = in.get_property_value(12);
		previous = in.get_property_value(13);
		previous_ambitag = in.get_property_value(14);
		category = in.get_category();
		word = in.get_property_value(16);
		next = in.get_property_value(17);
	}
	
	public void set_property_value(int index, String value)
	{
		switch(index)
		{
			case 0: ending = value; break;
			case 1: length = Byte.parseByte(value); break;
			case 2: has_apostrophe = (value.equals("0"))?false:true; break;
			case 3: has_digit = (value.equals("0"))?false:true; break;
			case 4: has_dot = (value.equals("0"))?false:true; break;
			case 5: has_comma = (value.equals("0"))?false:true; break;
			case 6: has_latin_character = (value.equals("0"))?false:true; break;
			case 7: ambitag = value; break;
			case 8: next_ending = value; break;
			case 9: next_ambitag = value; break;
			case 10: before_previous = value; break;
			case 11: before_previous_ending = value; break;
			case 12: previous_ending = value; break;
			case 13: previous = value; break;
			case 14: previous_ambitag = value; break;
			case 15: category = value; break;
			case 16: word = value; break;
			case 17: next = value;
		}
	}
	
	public String get_property_value(int index)
	{
		switch(index)
		{
			case 0: return ending;
			case 1: return length+"";
			case 2: return (has_apostrophe)?"1":"0";
			case 3: return (has_digit)?"1":"0";
			case 4: return (has_dot)?"1":"0";
			case 5: return (has_comma)?"1":"0";
			case 6: return (has_latin_character)?"1":"0";
			case 7: return ambitag;
			case 8: return next_ending;
			case 9: return next_ambitag;
			case 10: return before_previous;
			case 11: return before_previous_ending;
			case 12: return previous_ending;
			case 13: return previous;
			case 14: return previous_ambitag;
			case 15: return category;
			case 16: return word;
			case 17: return next;
		}
		return "";
	}
	
	public String get_category()
	{
		return category;
	}

	public boolean property_is_number(int property_index)
	{
		//the length of the word
		if(property_index == 1)
		{
			return true;
		}
		return false;
	}
	
	public int get_number_of_properties()
	{
		//last property is the next word (17)
		//pre-last property is the instance word (16)
		//pre-pre-last property is the category (15)
		return 15;
	}
	
	public String toString()
	{
		String instance_string = "";
		for(int i=0; i<18; ++i)
		{
			instance_string += get_property_value(i) + " ";
		}
		return instance_string.substring(0, instance_string.length()-1);
	}
	
	private String ending;
	private byte length;
	private boolean has_apostrophe;
	private boolean has_digit;
	private boolean has_dot;
	private boolean has_comma;
	private boolean has_latin_character;
	private String ambitag;
	private String next_ending;
	private String next_ambitag;
	private String before_previous;
	private String before_previous_ending;
	private String previous_ending;
	private String previous;
	private String previous_ambitag;
	private String category;
	private String word;
	private String next;
	
}




