package classifier.knowledge_tree;

import java.util.*;
import classifier.Instance;

public class Knowledge_node
{

	public Knowledge_node(byte d)
	{
		depth = d;
		//if its a leaf
		if(new Instance().get_number_of_properties() == d)
		{
			instances = new ArrayList<String>();
			children = null;
		}
		//else
		else
		{
			instances = null;
			children = new HashMap<String, Knowledge_node>();
		}
	}
	
	//returns the depth of this knowledge_node
	public int get_depth()
	{
		return depth;
	}
	
	//adds a new instance to the collection of this knowledge_node if it is a leaf
	//or passes it to its corresponding child
	public void add_instance(Instance instance)
	{
		//if this node is a leaf
		if(depth == instance.get_number_of_properties())
		{
			instances.add(instance.get_category());
		}
		//else pass the instance in the corresponding child
		else
		{
			//if an edge for the property's value already exists
			if(children.containsKey(instance.get_property_value(depth)))
			{
				//pass to it the incoming instance
				children.get(instance.get_property_value(depth)).add_instance(instance);
			}
			//else
			else
			{
				//create new edge under this knowledge_node
				Knowledge_node new_child = new Knowledge_node((byte)(depth+1));
				children.put(instance.get_property_value(depth), new_child);
				//and pass the instance to this child
				new_child.add_instance(instance);
			}
		}
	}
	
	//returns all children of this knowledge_node
	public HashMap<String, Knowledge_node> get_children()
	{
		return children;
	}
	
	//returns the instances - invoked only for leafs
	public ArrayList<String> get_instances()
	{
		return instances;
	}
	
	//the depth of a knowledge_node represents the index of the property it is responsible for
	private byte depth;
	//when expansion is completed only the leafs of the tree should hold instances
	private ArrayList<String> instances;
	//all knowledge_nodes that are under this knowledge_node
	private HashMap<String, Knowledge_node> children;
	
}
