package classifier.property_value_difference_metric;

import java.util.*;
import classifier.Instance;

public class Overlap_difference_metric implements Property_value_difference_metric
{
	
	public Overlap_difference_metric(ArrayList<Instance> knowledge)
	{
		//calculate the max-min values for number properties
		max_minus_min_number_property_for_overlap_metric = new TreeMap<Integer, Integer>();
		//if the training set is not empty
		if(knowledge.size() > 0)
		{
			//for each property
			for(int i=0; i<knowledge.get(0).get_number_of_properties(); ++i)
			{
				//if the property is of type number
				if(knowledge.get(0).property_is_number(i))
				{
					int max = Integer.MIN_VALUE;
					int min = Integer.MAX_VALUE;
					//check each instance in the train set
					for(int j=0; j< knowledge.size(); ++j)
					{
						//find the properties max and min value
						int x = Integer.parseInt(knowledge.get(j).get_property_value(i));
						if(x > max)
						{
							max = x;
						}
						if(x < min)
						{
							min = x;
						}
					}
					//and keep their difference
					max_minus_min_number_property_for_overlap_metric.put(new Integer(i),
							new Integer(max - min));
				}
			}
		}
	}
	
	//returns the difference of the values of two properties in the given instances
	public double get_difference(int property_index, Instance in, Instance in2)
	{
		//if property is number return
		//(in.value-in2.value)/max_property_value-min_property_value
		if(in.property_is_number(property_index))
		{
			try
			{
				return Math.abs(Integer.parseInt(in.get_property_value(property_index)) -
						Integer.parseInt(in2.get_property_value(property_index)))/
						max_minus_min_number_property_for_overlap_metric.get(property_index);
			}
			catch(Exception e)
			{
				//cannot divide by zero
				if(in.get_property_value(property_index).equals(
						in2.get_property_value(property_index)))
				{
					return 0;
				}
				return 1;
			}
		}
		//else 0 if values are same else 1
		else if(in.get_property_value(property_index).equals(
				in2.get_property_value(property_index)))
		{
			return 0;
		}
		return 1;
	}
	
	//the first integer holds the property index and the second the difference
	//max_value - min_value. this way we only go through all the training vectors
	//once for each property that is a number
	private TreeMap<Integer, Integer> max_minus_min_number_property_for_overlap_metric;
	
}
