package converter;

import java.util.*;

public class Converter
{

	static
	{
		initialize_sets();
	}
	
	private static void initialize_sets()
	{
		tags_to_codes = new HashMap<String, String>();
		codes_to_tags = new HashMap<String, String>();
		
		tags_to_codes.put("article/definite/nominative/masculine/singular", "0");
		tags_to_codes.put("article/definite/nominative/masculine/plural", "1");
		tags_to_codes.put("article/definite/nominative/masculine/--", "2");
		tags_to_codes.put("article/definite/nominative/feminine/singular", "3");
		tags_to_codes.put("article/definite/nominative/feminine/plural", "4");
		tags_to_codes.put("article/definite/nominative/feminine/--", "5");
		tags_to_codes.put("article/definite/nominative/neuter/singular", "6");
		tags_to_codes.put("article/definite/nominative/neuter/plural", "7");
		tags_to_codes.put("article/definite/nominative/neuter/--", "8");
		tags_to_codes.put("article/definite/nominative/--/singular", "9");
		tags_to_codes.put("article/definite/nominative/--/plural", "a");
		tags_to_codes.put("article/definite/nominative/--/--", "b");
		tags_to_codes.put("article/definite/genitive/masculine/singular", "c");
		tags_to_codes.put("article/definite/genitive/masculine/plural", "d");
		tags_to_codes.put("article/definite/genitive/masculine/--", "e");
		tags_to_codes.put("article/definite/genitive/feminine/singular", "f");
		tags_to_codes.put("article/definite/genitive/feminine/plural", "g");
		tags_to_codes.put("article/definite/genitive/feminine/--", "h");
		tags_to_codes.put("article/definite/genitive/neuter/singular", "i");
		tags_to_codes.put("article/definite/genitive/neuter/plural", "j");
		tags_to_codes.put("article/definite/genitive/neuter/--", "k");
		tags_to_codes.put("article/definite/genitive/--/singular", "l");
		tags_to_codes.put("article/definite/genitive/--/plural", "m");
		tags_to_codes.put("article/definite/genitive/--/--", "n");
		tags_to_codes.put("article/definite/accusative/masculine/singular", "o");
		tags_to_codes.put("article/definite/accusative/masculine/plural", "p");
		tags_to_codes.put("article/definite/accusative/masculine/--", "q");
		tags_to_codes.put("article/definite/accusative/feminine/singular", "r");
		tags_to_codes.put("article/definite/accusative/feminine/plural", "s");
		tags_to_codes.put("article/definite/accusative/feminine/--", "t");
		tags_to_codes.put("article/definite/accusative/neuter/singular", "u");
		tags_to_codes.put("article/definite/accusative/neuter/plural", "v");
		tags_to_codes.put("article/definite/accusative/neuter/--", "w");
		tags_to_codes.put("article/definite/accusative/--/singular", "x");
		tags_to_codes.put("article/definite/accusative/--/plural", "y");
		tags_to_codes.put("article/definite/accusative/--/--", "z");
		tags_to_codes.put("article/definite/vocative/masculine/singular", "A");
		tags_to_codes.put("article/definite/vocative/masculine/plural", "B");
		tags_to_codes.put("article/definite/vocative/masculine/--", "C");
		tags_to_codes.put("article/definite/vocative/feminine/singular", "D");
		tags_to_codes.put("article/definite/vocative/feminine/plural", "E");
		tags_to_codes.put("article/definite/vocative/feminine/--", "F");
		tags_to_codes.put("article/definite/vocative/neuter/singular", "G");
		tags_to_codes.put("article/definite/vocative/neuter/plural", "H");
		tags_to_codes.put("article/definite/vocative/neuter/--", "I");
		tags_to_codes.put("article/definite/vocative/--/singular", "G");
		tags_to_codes.put("article/definite/vocative/--/plural", "K");
		tags_to_codes.put("article/definite/vocative/--/--", "L");
		tags_to_codes.put("article/definite/--/masculine/singular", "M");
		tags_to_codes.put("article/definite/--/masculine/plural", "N");
		tags_to_codes.put("article/definite/--/masculine/--", "O");
		tags_to_codes.put("article/definite/--/feminine/singular", "P");
		tags_to_codes.put("article/definite/--/feminine/plural", "Q");
		tags_to_codes.put("article/definite/--/feminine/--", "R");
		tags_to_codes.put("article/definite/--/neuter/singular", "S");
		tags_to_codes.put("article/definite/--/neuter/plural", "T");
		tags_to_codes.put("article/definite/--/neuter/--", "U");
		tags_to_codes.put("article/definite/--/--/singular", "V");
		tags_to_codes.put("article/definite/--/--/plural", "W");
		tags_to_codes.put("article/definite/--/--/--", "X");
		tags_to_codes.put("article/indefinite/nominative/masculine/singular", "Y");
		tags_to_codes.put("article/indefinite/nominative/masculine/--", "Z");
		tags_to_codes.put("article/indefinite/nominative/feminine/singular", "00");
		tags_to_codes.put("article/indefinite/nominative/feminine/--", "01");
		tags_to_codes.put("article/indefinite/nominative/neuter/singular", "02");
		tags_to_codes.put("article/indefinite/nominative/neuter/--", "03");
		tags_to_codes.put("article/indefinite/nominative/--/singular", "04");
		tags_to_codes.put("article/indefinite/nominative/--/--", "05");
		tags_to_codes.put("article/indefinite/genitive/masculine/singular", "06");
		tags_to_codes.put("article/indefinite/genitive/masculine/--", "07");
		tags_to_codes.put("article/indefinite/genitive/feminine/singular", "08");
		tags_to_codes.put("article/indefinite/genitive/feminine/--", "09");
		tags_to_codes.put("article/indefinite/genitive/neuter/singular", "0a");
		tags_to_codes.put("article/indefinite/genitive/neuter/--", "0b");
		tags_to_codes.put("article/indefinite/genitive/--/singular", "0c");
		tags_to_codes.put("article/indefinite/genitive/--/--", "0d");
		tags_to_codes.put("article/indefinite/accusative/masculine/singular", "0e");
		tags_to_codes.put("article/indefinite/accusative/masculine/--", "0f");
		tags_to_codes.put("article/indefinite/accusative/feminine/singular", "0g");
		tags_to_codes.put("article/indefinite/accusative/feminine/--", "0h");
		tags_to_codes.put("article/indefinite/accusative/neuter/singular", "0i");
		tags_to_codes.put("article/indefinite/accusative/neuter/--", "0g");
		tags_to_codes.put("article/indefinite/accusative/--/singular", "0k");
		tags_to_codes.put("article/indefinite/accusative/--/--", "0l");
		tags_to_codes.put("article/indefinite/vocative/masculine/singular", "0m");
		tags_to_codes.put("article/indefinite/vocative/masculine/--", "0n");
		tags_to_codes.put("article/indefinite/vocative/feminine/singular", "0o");
		tags_to_codes.put("article/indefinite/vocative/feminine/--", "0p");
		tags_to_codes.put("article/indefinite/vocative/neuter/singular", "0q");
		tags_to_codes.put("article/indefinite/vocative/neuter/--", "0r");
		tags_to_codes.put("article/indefinite/vocative/--/singular", "0r");
		tags_to_codes.put("article/indefinite/vocative/--/--", "0s");
		tags_to_codes.put("article/indefinite/--/masculine/singular", "0t");
		tags_to_codes.put("article/indefinite/--/masculine/--", "0u");
		tags_to_codes.put("article/indefinite/--/feminine/singular", "0v");
		tags_to_codes.put("article/indefinite/--/feminine/--", "0w");
		tags_to_codes.put("article/indefinite/--/neuter/singular", "0x");
		tags_to_codes.put("article/indefinite/--/neuter/--", "0y");
		tags_to_codes.put("article/indefinite/--/--/singular", "0z");
		tags_to_codes.put("article/indefinite/--/--/--", "0A");
		tags_to_codes.put("article/prepositional/nominative/masculine/singular", "0B");
		tags_to_codes.put("article/prepositional/nominative/masculine/plural", "0C");
		tags_to_codes.put("article/prepositional/nominative/masculine/--", "0D");
		tags_to_codes.put("article/prepositional/nominative/feminine/singular", "0E");
		tags_to_codes.put("article/prepositional/nominative/feminine/plural", "0F");
		tags_to_codes.put("article/prepositional/nominative/feminine/--", "0G");
		tags_to_codes.put("article/prepositional/nominative/neuter/singular", "0H");
		tags_to_codes.put("article/prepositional/nominative/neuter/plural", "0I");
		tags_to_codes.put("article/prepositional/nominative/neuter/--", "0J");
		tags_to_codes.put("article/prepositional/nominative/--/singular", "0K");
		tags_to_codes.put("article/prepositional/nominative/--/plural", "0L");
		tags_to_codes.put("article/prepositional/nominative/--/--", "0M");
		tags_to_codes.put("article/prepositional/genitive/masculine/singular", "0N");
		tags_to_codes.put("article/prepositional/genitive/masculine/plural", "0O");
		tags_to_codes.put("article/prepositional/genitive/masculine/--", "0P");
		tags_to_codes.put("article/prepositional/genitive/feminine/singular", "0Q");
		tags_to_codes.put("article/prepositional/genitive/feminine/plural", "0R");
		tags_to_codes.put("article/prepositional/genitive/feminine/--", "0S");
		tags_to_codes.put("article/prepositional/genitive/neuter/singular", "0T");
		tags_to_codes.put("article/prepositional/genitive/neuter/plural", "0U");
		tags_to_codes.put("article/prepositional/genitive/neuter/--", "0V");
		tags_to_codes.put("article/prepositional/genitive/--/singular", "0W");
		tags_to_codes.put("article/prepositional/genitive/--/plural", "0X");
		tags_to_codes.put("article/prepositional/genitive/--/--", "0Y");
		tags_to_codes.put("article/prepositional/accusative/masculine/singular", "0Z");
		tags_to_codes.put("article/prepositional/accusative/masculine/plural", "10");
		tags_to_codes.put("article/prepositional/accusative/masculine/--", "11");
		tags_to_codes.put("article/prepositional/accusative/feminine/singular", "12");
		tags_to_codes.put("article/prepositional/accusative/feminine/plural", "13");
		tags_to_codes.put("article/prepositional/accusative/feminine/--", "14");
		tags_to_codes.put("article/prepositional/accusative/neuter/singular", "15");
		tags_to_codes.put("article/prepositional/accusative/neuter/plural", "16");
		tags_to_codes.put("article/prepositional/accusative/neuter/--", "17");
		tags_to_codes.put("article/prepositional/accusative/--/singular", "18");
		tags_to_codes.put("article/prepositional/accusative/--/plural", "19");
		tags_to_codes.put("article/prepositional/accusative/--/--", "1a");
		tags_to_codes.put("article/prepositional/vocative/masculine/singular", "1b");
		tags_to_codes.put("article/prepositional/vocative/masculine/plural", "1c");
		tags_to_codes.put("article/prepositional/vocative/masculine/--", "1d");
		tags_to_codes.put("article/prepositional/vocative/feminine/singular", "1e");
		tags_to_codes.put("article/prepositional/vocative/feminine/plural", "1f");
		tags_to_codes.put("article/prepositional/vocative/feminine/--", "1g");
		tags_to_codes.put("article/prepositional/vocative/neuter/singular", "1h");
		tags_to_codes.put("article/prepositional/vocative/neuter/plural", "1i");
		tags_to_codes.put("article/prepositional/vocative/neuter/--", "1j");
		tags_to_codes.put("article/prepositional/vocative/--/singular", "1k");
		tags_to_codes.put("article/prepositional/vocative/--/plural", "1l");
		tags_to_codes.put("article/prepositional/vocative/--/--", "1m");
		tags_to_codes.put("article/prepositional/--/masculine/singular", "1n");
		tags_to_codes.put("article/prepositional/--/masculine/plural", "1o");
		tags_to_codes.put("article/prepositional/--/masculine/--", "1p");
		tags_to_codes.put("article/prepositional/--/feminine/singular", "1q");
		tags_to_codes.put("article/prepositional/--/feminine/plural", "1r");
		tags_to_codes.put("article/prepositional/--/feminine/--", "1s");
		tags_to_codes.put("article/prepositional/--/neuter/singular", "1t");
		tags_to_codes.put("article/prepositional/--/neuter/plural", "1u");
		tags_to_codes.put("article/prepositional/--/neuter/--", "1v");
		tags_to_codes.put("article/prepositional/--/--/singular", "1w");
		tags_to_codes.put("article/prepositional/--/--/plural", "1x");
		tags_to_codes.put("article/prepositional/--/--/--", "1y");
		tags_to_codes.put("article/--/nominative/masculine/singular", "1z");
		tags_to_codes.put("article/--/nominative/masculine/plural", "1A");
		tags_to_codes.put("article/--/nominative/masculine/--", "1B");
		tags_to_codes.put("article/--/nominative/feminine/singular", "1C");
		tags_to_codes.put("article/--/nominative/feminine/plural", "1D");
		tags_to_codes.put("article/--/nominative/feminine/--", "1E");
		tags_to_codes.put("article/--/nominative/neuter/singular", "1F");
		tags_to_codes.put("article/--/nominative/neuter/plural", "1G");
		tags_to_codes.put("article/--/nominative/neuter/--", "1H");
		tags_to_codes.put("article/--/nominative/--/singular", "1I");
		tags_to_codes.put("article/--/nominative/--/plural", "1J");
		tags_to_codes.put("article/--/nominative/--/--", "1K");
		tags_to_codes.put("article/--/genitive/masculine/singular", "1L");
		tags_to_codes.put("article/--/genitive/masculine/plural", "1M");
		tags_to_codes.put("article/--/genitive/masculine/--", "1N");
		tags_to_codes.put("article/--/genitive/feminine/singular", "1O");
		tags_to_codes.put("article/--/genitive/feminine/plural", "1P");
		tags_to_codes.put("article/--/genitive/feminine/--", "1Q");
		tags_to_codes.put("article/--/genitive/neuter/singular", "1R");
		tags_to_codes.put("article/--/genitive/neuter/plural", "1S");
		tags_to_codes.put("article/--/genitive/neuter/--", "1T");
		tags_to_codes.put("article/--/genitive/--/singular", "1U");
		tags_to_codes.put("article/--/genitive/--/plural", "1V");
		tags_to_codes.put("article/--/genitive/--/--", "1W");
		tags_to_codes.put("article/--/accusative/masculine/singular", "1X");
		tags_to_codes.put("article/--/accusative/masculine/plural", "1Y");
		tags_to_codes.put("article/--/accusative/masculine/--", "1Z");
		tags_to_codes.put("article/--/accusative/feminine/singular", "20");
		tags_to_codes.put("article/--/accusative/feminine/plural", "21");
		tags_to_codes.put("article/--/accusative/feminine/--", "22");
		tags_to_codes.put("article/--/accusative/neuter/singular", "23");
		tags_to_codes.put("article/--/accusative/neuter/plural", "24");
		tags_to_codes.put("article/--/accusative/neuter/--", "25");
		tags_to_codes.put("article/--/accusative/--/singular", "26");
		tags_to_codes.put("article/--/accusative/--/plural", "27");
		tags_to_codes.put("article/--/accusative/--/--", "28");
		tags_to_codes.put("article/--/vocative/masculine/singular", "29");
		tags_to_codes.put("article/--/vocative/masculine/plural", "2a");
		tags_to_codes.put("article/--/vocative/masculine/--", "2b");
		tags_to_codes.put("article/--/vocative/feminine/singular", "2c");
		tags_to_codes.put("article/--/vocative/feminine/plural", "2d");
		tags_to_codes.put("article/--/vocative/feminine/--", "2e");
		tags_to_codes.put("article/--/vocative/neuter/singular", "2f");
		tags_to_codes.put("article/--/vocative/neuter/plural", "2g");
		tags_to_codes.put("article/--/vocative/neuter/--", "2h");
		tags_to_codes.put("article/--/vocative/--/singular", "2i");
		tags_to_codes.put("article/--/vocative/--/plural", "2j");
		tags_to_codes.put("article/--/vocative/--/--", "2k");
		tags_to_codes.put("article/--/--/masculine/singular", "2l");
		tags_to_codes.put("article/--/--/masculine/plural", "2m");
		tags_to_codes.put("article/--/--/masculine/--", "2n");
		tags_to_codes.put("article/--/--/feminine/singular", "2o");
		tags_to_codes.put("article/--/--/feminine/plural", "2p");
		tags_to_codes.put("article/--/--/feminine/--", "2q");
		tags_to_codes.put("article/--/--/neuter/singular", "2r");
		tags_to_codes.put("article/--/--/neuter/plural", "2s");
		tags_to_codes.put("article/--/--/neuter/--", "2t");
		tags_to_codes.put("article/--/--/--/singular", "2u");
		tags_to_codes.put("article/--/--/--/plural", "2v");
		tags_to_codes.put("article/--/--/--/--", "2w");
		
		tags_to_codes.put("verb/--/active/singular/present", "2x");
		tags_to_codes.put("verb/--/active/singular/past", "2y");
		tags_to_codes.put("verb/--/active/singular/future", "2z");
		tags_to_codes.put("verb/--/active/singular/--", "2A");
		tags_to_codes.put("verb/--/active/plural/present", "2B");
		tags_to_codes.put("verb/--/active/plural/past", "2C");
		tags_to_codes.put("verb/--/active/plural/future", "2D");
		tags_to_codes.put("verb/--/active/plural/--", "2E");
		tags_to_codes.put("verb/--/active/--/present", "2F");
		tags_to_codes.put("verb/--/active/--/past", "2G");
		tags_to_codes.put("verb/--/active/--/future", "2H");
		tags_to_codes.put("verb/--/active/--/--", "2I");
		tags_to_codes.put("verb/--/passive/singular/present", "2J");
		tags_to_codes.put("verb/--/passive/singular/past", "2K");
		tags_to_codes.put("verb/--/passive/singular/future", "2L");
		tags_to_codes.put("verb/--/passive/singular/--", "2M");
		tags_to_codes.put("verb/--/passive/plural/present", "2N");
		tags_to_codes.put("verb/--/passive/plural/past", "2O");
		tags_to_codes.put("verb/--/passive/plural/future", "2P");
		tags_to_codes.put("verb/--/passive/plural/--", "2Q");
		tags_to_codes.put("verb/--/passive/--/present", "2R");
		tags_to_codes.put("verb/--/passive/--/past", "2S");
		tags_to_codes.put("verb/--/passive/--/future", "2T");
		tags_to_codes.put("verb/--/passive/--/--", "2U");
		tags_to_codes.put("verb/--/--/singular/present", "2V");
		tags_to_codes.put("verb/--/--/singular/past", "2W");
		tags_to_codes.put("verb/--/--/singular/future", "2X");
		tags_to_codes.put("verb/--/--/singular/--", "2Y");
		tags_to_codes.put("verb/--/--/plural/present", "2Z");
		tags_to_codes.put("verb/--/--/plural/past", "30");
		tags_to_codes.put("verb/--/--/plural/future", "31");
		tags_to_codes.put("verb/--/--/plural/--", "32");
		tags_to_codes.put("verb/--/--/--/present", "33");
		tags_to_codes.put("verb/--/--/--/past", "34");
		tags_to_codes.put("verb/--/--/--/future", "35");
		tags_to_codes.put("verb/--/--/--/--", "36");
		tags_to_codes.put("verb/infinitive/active/--/--", "37");
		tags_to_codes.put("verb/infinitive/passive/--/--", "38");
		tags_to_codes.put("verb/infinitive/--/--/--", "39");
		tags_to_codes.put("verb/participle/--/--/--", "3a");
		
		tags_to_codes.put("punctuation/--/--/--/--", "3b");
		
		tags_to_codes.put("adjective/nominative/masculine/singular/--", "3c");
		tags_to_codes.put("adjective/nominative/masculine/plural/--", "3d");
		tags_to_codes.put("adjective/nominative/masculine/--/--", "3e");
		tags_to_codes.put("adjective/nominative/feminine/singular/--", "3f");
		tags_to_codes.put("adjective/nominative/feminine/plural/--", "3g");
		tags_to_codes.put("adjective/nominative/feminine/--/--", "3h");
		tags_to_codes.put("adjective/nominative/neuter/singular/--", "3i");
		tags_to_codes.put("adjective/nominative/neuter/plural/--", "3j");
		tags_to_codes.put("adjective/nominative/neuter/--/--", "3k");
		tags_to_codes.put("adjective/nominative/--/singular/--", "3l");
		tags_to_codes.put("adjective/nominative/--/plural/--", "3m");
		tags_to_codes.put("adjective/nominative/--/--/--", "3n");
		tags_to_codes.put("adjective/genitive/masculine/singular/--", "3o");
		tags_to_codes.put("adjective/genitive/masculine/plural/--", "3p");
		tags_to_codes.put("adjective/genitive/masculine/--/--", "3q");
		tags_to_codes.put("adjective/genitive/feminine/singular/--", "3r");
		tags_to_codes.put("adjective/genitive/feminine/plural/--", "3s");
		tags_to_codes.put("adjective/genitive/feminine/--/--", "3t");
		tags_to_codes.put("adjective/genitive/neuter/singular/--", "3u");
		tags_to_codes.put("adjective/genitive/neuter/plural/--", "3v");
		tags_to_codes.put("adjective/genitive/neuter/--/--", "3w");
		tags_to_codes.put("adjective/genitive/--/singular/--", "3x");
		tags_to_codes.put("adjective/genitive/--/plural/--", "3y");
		tags_to_codes.put("adjective/genitive/--/--/--", "3z");
		tags_to_codes.put("adjective/accusative/masculine/singular/--", "3A");
		tags_to_codes.put("adjective/accusative/masculine/plural/--", "3B");
		tags_to_codes.put("adjective/accusative/masculine/--/--", "3C");
		tags_to_codes.put("adjective/accusative/feminine/singular/--", "3D");
		tags_to_codes.put("adjective/accusative/feminine/plural/--", "3E");
		tags_to_codes.put("adjective/accusative/feminine/--/--", "3F");
		tags_to_codes.put("adjective/accusative/neuter/singular/--", "3G");
		tags_to_codes.put("adjective/accusative/neuter/plural/--", "3H");
		tags_to_codes.put("adjective/accusative/neuter/--/--", "3I");
		tags_to_codes.put("adjective/accusative/--/singular/--", "3J");
		tags_to_codes.put("adjective/accusative/--/plural/--", "3K");
		tags_to_codes.put("adjective/accusative/--/--/--", "3L");
		tags_to_codes.put("adjective/vocative/masculine/singular/--", "3M");
		tags_to_codes.put("adjective/vocative/masculine/plural/--", "3N");
		tags_to_codes.put("adjective/vocative/masculine/--/--", "3O");
		tags_to_codes.put("adjective/vocative/feminine/singular/--", "3P");
		tags_to_codes.put("adjective/vocative/feminine/plural/--", "3Q");
		tags_to_codes.put("adjective/vocative/feminine/--/--", "3R");
		tags_to_codes.put("adjective/vocative/neuter/singular/--", "3S");
		tags_to_codes.put("adjective/vocative/neuter/plural/--", "3T");
		tags_to_codes.put("adjective/vocative/neuter/--/--", "3U");
		tags_to_codes.put("adjective/vocative/--/singular/--", "3V");
		tags_to_codes.put("adjective/vocative/--/plural/--", "3W");
		tags_to_codes.put("adjective/vocative/--/--/--", "3X");
		tags_to_codes.put("adjective/--/masculine/singular/--", "3Y");
		tags_to_codes.put("adjective/--/masculine/plural/--", "3Z");
		tags_to_codes.put("adjective/--/masculine/--/--", "40");
		tags_to_codes.put("adjective/--/feminine/singular/--", "41");
		tags_to_codes.put("adjective/--/feminine/plural/--", "42");
		tags_to_codes.put("adjective/--/feminine/--/--", "43");
		tags_to_codes.put("adjective/--/neuter/singular/--", "44");
		tags_to_codes.put("adjective/--/neuter/plural/--", "45");
		tags_to_codes.put("adjective/--/neuter/--/--", "46");
		tags_to_codes.put("adjective/--/--/singular/--", "47");
		tags_to_codes.put("adjective/--/--/plural/--", "48");
		tags_to_codes.put("adjective/--/--/--/--", "49");
		
		tags_to_codes.put("adverb/--/--/--/--", "4a");
		
		tags_to_codes.put("conjunction/--/--/--/--", "4b");
		
		tags_to_codes.put("noun/nominative/masculine/singular/--", "4c");
		tags_to_codes.put("noun/nominative/masculine/plural/--", "4d");
		tags_to_codes.put("noun/nominative/masculine/--/--", "4e");
		tags_to_codes.put("noun/nominative/feminine/singular/--", "4f");
		tags_to_codes.put("noun/nominative/feminine/plural/--", "4g");
		tags_to_codes.put("noun/nominative/feminine/--/--", "4h");
		tags_to_codes.put("noun/nominative/neuter/singular/--", "4i");
		tags_to_codes.put("noun/nominative/neuter/plural/--", "4j");
		tags_to_codes.put("noun/nominative/neuter/--/--", "4k");
		tags_to_codes.put("noun/nominative/--/singular/--", "4l");
		tags_to_codes.put("noun/nominative/--/plural/--", "4m");
		tags_to_codes.put("noun/nominative/--/--/--", "4n");
		tags_to_codes.put("noun/genitive/masculine/singular/--", "4o");
		tags_to_codes.put("noun/genitive/masculine/plural/--", "4p");
		tags_to_codes.put("noun/genitive/masculine/--/--", "4q");
		tags_to_codes.put("noun/genitive/feminine/singular/--", "4r");
		tags_to_codes.put("noun/genitive/feminine/plural/--", "4s");
		tags_to_codes.put("noun/genitive/feminine/--/--", "4t");
		tags_to_codes.put("noun/genitive/neuter/singular/--", "4u");
		tags_to_codes.put("noun/genitive/neuter/plural/--", "4v");
		tags_to_codes.put("noun/genitive/neuter/--/--", "4w");
		tags_to_codes.put("noun/genitive/--/singular/--", "4x");
		tags_to_codes.put("noun/genitive/--/plural/--", "4y");
		tags_to_codes.put("noun/genitive/--/--/--", "4z");
		tags_to_codes.put("noun/accusative/masculine/singular/--", "4A");
		tags_to_codes.put("noun/accusative/masculine/plural/--", "4B");
		tags_to_codes.put("noun/accusative/masculine/--/--", "4C");
		tags_to_codes.put("noun/accusative/feminine/singular/--", "4D");
		tags_to_codes.put("noun/accusative/feminine/plural/--", "4E");
		tags_to_codes.put("noun/accusative/feminine/--/--", "4F");
		tags_to_codes.put("noun/accusative/neuter/singular/--", "4G");
		tags_to_codes.put("noun/accusative/neuter/plural/--", "4H");
		tags_to_codes.put("noun/accusative/neuter/--/--", "4I");
		tags_to_codes.put("noun/accusative/--/singular/--", "4J");
		tags_to_codes.put("noun/accusative/--/plural/--", "4K");
		tags_to_codes.put("noun/accusative/--/--/--", "4L");
		tags_to_codes.put("noun/vocative/masculine/singular/--", "4M");
		tags_to_codes.put("noun/vocative/masculine/plural/--", "4N");
		tags_to_codes.put("noun/vocative/masculine/--/--", "4O");
		tags_to_codes.put("noun/vocative/feminine/singular/--", "4P");
		tags_to_codes.put("noun/vocative/feminine/plural/--", "4Q");
		tags_to_codes.put("noun/vocative/feminine/--/--", "4R");
		tags_to_codes.put("noun/vocative/neuter/singular/--", "4S");
		tags_to_codes.put("noun/vocative/neuter/plural/--", "4T");
		tags_to_codes.put("noun/vocative/neuter/--/--", "4U");
		tags_to_codes.put("noun/vocative/--/singular/--", "4V");
		tags_to_codes.put("noun/vocative/--/plural/--", "4W");
		tags_to_codes.put("noun/vocative/--/--/--", "4X");
		tags_to_codes.put("noun/--/masculine/singular/--", "4Y");
		tags_to_codes.put("noun/--/masculine/plural/--", "4Z");
		tags_to_codes.put("noun/--/masculine/--/--", "50");
		tags_to_codes.put("noun/--/feminine/singular/--", "51");
		tags_to_codes.put("noun/--/feminine/plural/--", "52");
		tags_to_codes.put("noun/--/feminine/--/--", "53");
		tags_to_codes.put("noun/--/neuter/singular/--", "54");
		tags_to_codes.put("noun/--/neuter/plural/--", "55");
		tags_to_codes.put("noun/--/neuter/--/--", "56");
		tags_to_codes.put("noun/--/--/singular/--", "57");
		tags_to_codes.put("noun/--/--/plural/--", "58");
		tags_to_codes.put("noun/--/--/--/--", "59");
		
		tags_to_codes.put("numeral/--/--/--/--", "5a");
		
		tags_to_codes.put("particle/--/--/--/--", "5b");
		
		tags_to_codes.put("preposition/--/--/--/--", "5c");
		
		tags_to_codes.put("pronoun/--/nominative/masculine/singular", "5d");
		tags_to_codes.put("pronoun/--/nominative/masculine/plural", "5e");
		tags_to_codes.put("pronoun/--/nominative/masculine/--", "5f");
		tags_to_codes.put("pronoun/--/nominative/feminine/singular", "5g");
		tags_to_codes.put("pronoun/--/nominative/feminine/plural", "5h");
		tags_to_codes.put("pronoun/--/nominative/feminine/--", "5i");
		tags_to_codes.put("pronoun/--/nominative/neuter/singular", "5j");
		tags_to_codes.put("pronoun/--/nominative/neuter/plural", "5k");
		tags_to_codes.put("pronoun/--/nominative/neuter/--", "5l");
		tags_to_codes.put("pronoun/--/nominative/--/singular", "5m");
		tags_to_codes.put("pronoun/--/nominative/--/plural", "5n");
		tags_to_codes.put("pronoun/--/nominative/--/--", "5o");
		tags_to_codes.put("pronoun/--/genitive/masculine/singular", "5p");
		tags_to_codes.put("pronoun/--/genitive/masculine/plural", "5q");
		tags_to_codes.put("pronoun/--/genitive/masculine/--", "5r");
		tags_to_codes.put("pronoun/--/genitive/feminine/singular", "5s");
		tags_to_codes.put("pronoun/--/genitive/feminine/plural", "5t");
		tags_to_codes.put("pronoun/--/genitive/feminine/--", "5u");
		tags_to_codes.put("pronoun/--/genitive/neuter/singular", "5v");
		tags_to_codes.put("pronoun/--/genitive/neuter/plural", "5w");
		tags_to_codes.put("pronoun/--/genitive/neuter/--", "5x");
		tags_to_codes.put("pronoun/--/genitive/--/singular", "5y");
		tags_to_codes.put("pronoun/--/genitive/--/plural", "5z");
		tags_to_codes.put("pronoun/--/genitive/--/--", "5A");
		tags_to_codes.put("pronoun/--/accusative/masculine/singular", "5B");
		tags_to_codes.put("pronoun/--/accusative/masculine/plural", "5C");
		tags_to_codes.put("pronoun/--/accusative/masculine/--", "5D");
		tags_to_codes.put("pronoun/--/accusative/feminine/singular", "5E");
		tags_to_codes.put("pronoun/--/accusative/feminine/plural", "5F");
		tags_to_codes.put("pronoun/--/accusative/feminine/--", "5G");
		tags_to_codes.put("pronoun/--/accusative/neuter/singular", "5H");
		tags_to_codes.put("pronoun/--/accusative/neuter/plural", "5I");
		tags_to_codes.put("pronoun/--/accusative/neuter/--", "5J");
		tags_to_codes.put("pronoun/--/accusative/--/singular", "5K");
		tags_to_codes.put("pronoun/--/accusative/--/plural", "5L");
		tags_to_codes.put("pronoun/--/accusative/--/--", "5M");
		tags_to_codes.put("pronoun/--/vocative/masculine/singular", "5N");
		tags_to_codes.put("pronoun/--/vocative/masculine/plural", "5O");
		tags_to_codes.put("pronoun/--/vocative/masculine/--", "5P");
		tags_to_codes.put("pronoun/--/vocative/feminine/singular", "5Q");
		tags_to_codes.put("pronoun/--/vocative/feminine/plural", "5R");
		tags_to_codes.put("pronoun/--/vocative/feminine/--", "5S");
		tags_to_codes.put("pronoun/--/vocative/neuter/singular", "5T");
		tags_to_codes.put("pronoun/--/vocative/neuter/plural", "5U");
		tags_to_codes.put("pronoun/--/vocative/neuter/--", "5V");
		tags_to_codes.put("pronoun/--/vocative/--/singular", "5W");
		tags_to_codes.put("pronoun/--/vocative/--/plural", "5X");
		tags_to_codes.put("pronoun/--/vocative/--/--", "5Y");
		tags_to_codes.put("pronoun/--/--/masculine/singular", "5Z");
		tags_to_codes.put("pronoun/--/--/masculine/plural", "60");
		tags_to_codes.put("pronoun/--/--/masculine/--", "61");
		tags_to_codes.put("pronoun/--/--/feminine/singular", "62");
		tags_to_codes.put("pronoun/--/--/feminine/plural", "63");
		tags_to_codes.put("pronoun/--/--/feminine/--", "64");
		tags_to_codes.put("pronoun/--/--/neuter/singular", "65");
		tags_to_codes.put("pronoun/--/--/neuter/plural", "66");
		tags_to_codes.put("pronoun/--/--/neuter/--", "67");
		tags_to_codes.put("pronoun/--/--/--/singular", "68");
		tags_to_codes.put("pronoun/--/--/--/plural", "69");
		tags_to_codes.put("pronoun/--/--/--/--", "6a");
		tags_to_codes.put("pronoun/inflectionless/--/--/--", "6b");
		
		tags_to_codes.put("other/abbreviation/--/--/--", "6c");
		tags_to_codes.put("other/acronym/--/--/--", "6d");
		tags_to_codes.put("other/foreign_word/--/--/--", "6e");
		tags_to_codes.put("other/symbol/--/--/--", "6f");
		tags_to_codes.put("other/other/--/--/--", "6g");
		tags_to_codes.put("other/--/--/--/--", "6h");
		
		tags_to_codes.put("--/--/--/--/--", "6i");
		
		Iterator<String> it = tags_to_codes.keySet().iterator();
		
		while(it.hasNext())
		{
			String temp = it.next();
			codes_to_tags.put(tags_to_codes.get(temp), temp);
		}
	}
	
	public static String reverse(String s)
	{
		if(tags_to_codes.containsKey(s))
		{
			return tags_to_codes.get(s);
		}
		if(codes_to_tags.containsKey(s))
		{
			return codes_to_tags.get(s);
		}
		return null;
	}
	
	private static HashMap<String, String> tags_to_codes;
	private static HashMap<String, String> codes_to_tags;
	
}
