package gui.active_learning_tool;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.net.URL;

import javax.imageio.ImageIO;
import javax.swing.*;
import javax.swing.text.DefaultHighlighter;

import auxiliary_folder_handling.*;

public class Active_learning_tool_category_filling extends JFrame
{

	public Active_learning_tool_category_filling(Proposer p, boolean high_tag,
			String[] s, int[] start, int[] end, String[] w, String[] c)
	{
		//the title
		super("Category Selection");
		proposer = p;
		extended_tag = high_tag;
		sentences = s;
		startings = start;
		endings = end;
		categories = c;
		words = w;
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setResizable(false);
		setSize(570, 175);
		//appear in the center of the screen
		setLocationRelativeTo(null);
		file_separator = System.getProperty("file.separator");
		file_separator = (file_separator.equals("\\"))?"\\\\":file_separator;
		//change the frame icon
		BufferedImage image = null;
        try
        {
        	image = ImageIO.read(new URL("file:"+new File("pics" + file_separator + "icon.JPG").getAbsolutePath()));
        }
        catch (IOException e)
        {
            e.printStackTrace();
        }
        setIconImage(image);
	}
	
	//shows the frame
	public void init()
	{
		current_sentence = 0;
		panel = new Category_filling_panel(
				this, extended_tag, sentences[0], startings[0],
				endings[0], 1, sentences.length, words[0], categories[0],false,
				(sentences.length == 1)?true:false);
		setContentPane(panel);
		setVisible(true);
	}
	
	//shows the previous sentence
	public void show_previous_sentence(String category)
	{
		categories[current_sentence] = category;
		current_sentence--;
		if(current_sentence == 0)
		{
			setContentPane(new Category_filling_panel(
					this, extended_tag, sentences[current_sentence],
					startings[current_sentence], endings[current_sentence], current_sentence+1,
					sentences.length, words[current_sentence], categories[current_sentence], false, false));
			getContentPane().setVisible(false);
			getContentPane().setVisible(true);
		}
		else
		{
			setContentPane(new Category_filling_panel(
					this, extended_tag, sentences[current_sentence],
					startings[current_sentence], endings[current_sentence], current_sentence+1,
					sentences.length, words[current_sentence], categories[current_sentence], true, false));
			getContentPane().setVisible(false);
			getContentPane().setVisible(true);
		}
	}
	
	//shows the next sentence
	public void show_next_sentence(String category)
	{
		categories[current_sentence] = category;
		current_sentence++;
		//if all tokens have been tagged
		if(current_sentence == sentences.length)
		{
			proposer.categories_are_set(categories);
			this.dispose();
		}
		else if(current_sentence == sentences.length-1)
		{
			setContentPane(new Category_filling_panel(
					this, extended_tag, sentences[current_sentence],
					startings[current_sentence], endings[current_sentence], current_sentence+1,
					sentences.length, words[current_sentence], categories[current_sentence], true, true));
			getContentPane().setVisible(false);
			getContentPane().setVisible(true);
		}
		else
		{
			setContentPane(new Category_filling_panel(
				this, extended_tag, sentences[current_sentence],
				startings[current_sentence], endings[current_sentence], current_sentence+1,
				sentences.length, words[current_sentence], categories[current_sentence], true, false));
			getContentPane().setVisible(false);
			getContentPane().setVisible(true);
		}
	}
	
	//the panel of the category filling frame
	public class Category_filling_panel extends JPanel
	{

		//the sole constructor where all components of the panel are initialized
		public Category_filling_panel(final Active_learning_tool_category_filling frame,
				boolean high_tag, String sentence, int start, int end, int num, int num2,
				String word, String category, boolean show_previous, boolean last_sentence)
		{
			setBackground(new Color(239, 239, 239));
			use_high_detail_tag = high_tag;
			//the pos combo box
			pos_box = new JComboBox();
			pos_box.addItem("--");
			pos_box.addItem("article");
			pos_box.addItem("verb");
			pos_box.addItem("punctuation");
			pos_box.addItem("adjective");
			pos_box.addItem("adverb");
			pos_box.addItem("conjunction");
			pos_box.addItem("noun");
			pos_box.addItem("numeral");
			pos_box.addItem("particle");
			pos_box.addItem("preposition");
			pos_box.addItem("pronoun");
			pos_box.addItem("other");
			pos_box.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent event)
				{
					tag_changed((String)pos_box.getSelectedItem(),
							pos_panel.getComponentZOrder(pos_box));
				}
			});
			
			//the case combo box
			case_box = new JComboBox();
			case_box.addItem("--");
			case_box.addItem("nominative");
			case_box.addItem("genitive");
			case_box.addItem("accusative");
			case_box.addItem("vocative");
			case_box.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent event)
				{
					tag_changed((String)case_box.getSelectedItem(),
							pos_panel.getComponentZOrder(case_box));
				}
			});
			
			//the gender combo box
			gender_box = new JComboBox();
			gender_box.addItem("--");
			gender_box.addItem("masculine");
			gender_box.addItem("feminine");
			gender_box.addItem("neuter");
			gender_box.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent event)
				{
					tag_changed((String)gender_box.getSelectedItem(),
							pos_panel.getComponentZOrder(gender_box));
				}
			});
			
			//the tense combo box
			tense_box = new JComboBox();
			tense_box.addItem("--");
			tense_box.addItem("present");
			tense_box.addItem("past");
			tense_box.addItem("future");
			tense_box.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent event)
				{
					tag_changed((String)tense_box.getSelectedItem(),
							pos_panel.getComponentZOrder(tense_box));
				}
			});
			
			//the number combo box
			number_box = new JComboBox();
			number_box.addItem("--");
			number_box.addItem("singular");
			number_box.addItem("plural");
			number_box.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent event)
				{
					tag_changed((String)number_box.getSelectedItem(),
							pos_panel.getComponentZOrder(number_box));
				}
			});
			
			//the number singular combo box
			number_singular_box = new JComboBox();
			number_singular_box.addItem("--");
			number_singular_box.addItem("singular");
			number_singular_box.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent event)
				{
					tag_changed((String)number_singular_box.getSelectedItem(),
							pos_panel.getComponentZOrder(number_singular_box));
				}
			});
			
			//the type combo box
			type_box = new JComboBox();
			type_box.addItem("--");
			type_box.addItem("abbreviation");
			type_box.addItem("acronym");
			type_box.addItem("foreign word");
			type_box.addItem("symbol");
			type_box.addItem("other");
			type_box.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent event)
				{
					tag_changed((String)type_box.getSelectedItem(),
							pos_panel.getComponentZOrder(type_box));
				}
			});
			
			//the function combo box
			function_box = new JComboBox();
			function_box.addItem("--");
			function_box.addItem("definite");
			function_box.addItem("indefinite");
			function_box.addItem("prepositional");
			function_box.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent event)
				{
					tag_changed((String)function_box.getSelectedItem(),
							pos_panel.getComponentZOrder(function_box));
				}
			});
			
			//the pronoun mode combo box
			pronoun_mode_box = new JComboBox();
			pronoun_mode_box.addItem("--");
			pronoun_mode_box.addItem("inflectionless");
			pronoun_mode_box.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent event)
				{
					tag_changed((String)pronoun_mode_box.getSelectedItem(),
							pos_panel.getComponentZOrder(pronoun_mode_box));
				}
			});
			
			//the verb mode combo box
			verb_mode_box = new JComboBox();
			verb_mode_box.addItem("--");
			verb_mode_box.addItem("infinitive");
			verb_mode_box.addItem("participle");
			verb_mode_box.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent event)
				{
					tag_changed((String)verb_mode_box.getSelectedItem(),
							pos_panel.getComponentZOrder(verb_mode_box));
				}
			});
			
			//the voice combo box
			voice_box = new JComboBox();
			voice_box.addItem("--");
			voice_box.addItem("active");
			voice_box.addItem("passive");
			voice_box.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent event)
				{
					tag_changed((String)voice_box.getSelectedItem(),
							pos_panel.getComponentZOrder(voice_box));
				}
			});
			
			//the pos panel
			pos_panel = new JPanel();
			pos_panel.setPreferredSize(new Dimension(535, 30));
			pos_panel.setVisible(true);
			
			//adding components to the pos panel
			GridLayout layout = new GridLayout();
			//set the gaps between the combo boxes
			layout.setHgap(10);
			pos_panel.setLayout(layout);
			pos_panel.setBackground(new Color(239, 239, 239));
			
			pos_panel.add(pos_box);
			pos_panel.add(new JLabel());
			pos_panel.add(new JLabel());
			pos_panel.add(new JLabel());
			pos_panel.add(new JLabel());
			
			//the text area - where the given text appears as it is
			text_area = new JTextArea();
		    text_area.setFocusable(false);
		    text_area.setWrapStyleWord(true);
		    text_area.setLineWrap(true);
		    text_area.setText(sentence);
		    
		    //highlight the token
		    try
		    {
		    	text_area.getHighlighter().addHighlight(
					start, end,
					new DefaultHighlighter.DefaultHighlightPainter(
							new Color(255, 255, 100)));
		    }
		    catch(Exception e)
		    {
		    	e.printStackTrace();
		    }
		    
			//the scroll
			scroll = new JScrollPane();
			scroll.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
			scroll.setPreferredSize(new Dimension(535, 72));
		    scroll.setViewportView(text_area);
		    
		    //the label
		    label = new JLabel("Tagging token " + num + " of " + num2 + ": " + word);
		    if(show_previous)
		    {
		    	label.setPreferredSize(new Dimension(380, 13));
		    }
		    else
		    {
		    	label.setPreferredSize(new Dimension(469, 13));
		    }
		    
		    //the previous button
		    previous = new JButton("Previous");
		    previous.addActionListener(new ActionListener()
		    {
		    	public void actionPerformed(ActionEvent event)
		    	{
		    		frame.show_previous_sentence(values[0] + "/" +
		    				values[1] + "/" + values[2] + "/" + values[3] + "/" + values[4]);
		    	}
		    });
		    if(show_previous)
		    {
		    	previous.setVisible(true);
		    }
		    else
		    {
		    	previous.setVisible(false);
		    }
		    
		    //the next button
		    if(last_sentence)
		    {
		    	next = new JButton("Done");
		    	label.setPreferredSize(new Dimension(
		    			label.getPreferredSize().width-3, label.getPreferredSize().height));
		    }
		    else
		    {
		    	next = new JButton("Next");
		    }
		    next.addActionListener(new ActionListener()
		    {
		    	public void actionPerformed(ActionEvent event)
		    	{
		    		frame.show_next_sentence(values[0] + "/" +
		    				values[1] + "/" + values[2] + "/" + values[3] + "/" + values[4]);
		    	}
		    });
		    
	        //adding the components
	        add(pos_panel);
		    add(scroll);
		    add(label);
		    add(previous);
		    add(next);
		    
		    values = new String[5];
		    values[0] = category.split("/")[0];
		    values[1] = category.split("/")[1];
		    values[2] = category.split("/")[2];
		    values[3] = category.split("/")[3];
		    values[4] = category.split("/")[4];
		    show_combo_boxes_for_values(values[0], values[1], values[2], values[3], values[4]);
		    
		}
		
		//invoked when the tag changes
		private void tag_changed(String new_value, int box_number)
		{
			if(box_number == 0)
			{
				if(values[0] != new_value)
				{
				    values[0] = new_value;
				    values[1] = "--";
				    values[2] = "--";
				    values[3] = "--";
				    values[4] = "--";
				}
			}
			else
			{
				values[box_number] = new_value;
				//special occasions
				if(values[0].equals("article") &&
						new_value.equals("indefinite"))
				{
					values[4] = "singular";
				}
				if(values[0].equals("pronoun") &&
						new_value.equals("inflectionless"))
				{
					values[2] = "--";
					values[3] = "--";
					values[4] = "--";
				}
				if(values[0].equals("verb"))
				{
					if(values[1].equals("infinitive"))
					{
						values[3] = "--";
						values[4] = "--";
					}
					if(values[1].equals("participle"))
					{
						values[2] = "--";
						values[3] = "--";
						values[4] = "--";
					}
				}
			}
			show_combo_boxes_for_values(values[0], values[1], values[2],
					values[3], values[4]);
			
		}
		
		//according to the part of speech main tag the secondary tags should change properly
		private void show_combo_boxes_for_values(String value0,
				String value1, String value2, String value3, String value4)
		{
			
			//clear the pos_panel
			pos_panel.removeAll();
			
			//if we use low detail we only keep the main tag
			if(!use_high_detail_tag)
			{
				pos_panel.add(pos_box);
				pos_panel.add(new JLabel());
				pos_panel.add(new JLabel());
				pos_panel.add(new JLabel());
				pos_panel.add(new JLabel());
			}
			//else we add the corresponding secondary tags
			else if(value0.equals("--") || value0.equals("adverb") || value0.equals("conjunction")
					|| value0.equals("numeral") || value0.equals("particle") ||
					value0.equals("preposition") || value0.equals("punctuation"))
			{
				pos_panel.add(pos_box);
				pos_panel.add(new JLabel());
				pos_panel.add(new JLabel());
				pos_panel.add(new JLabel());
				pos_panel.add(new JLabel());
			}
			else if(value0.equals("adjective") || value0.equals("noun"))
			{
				pos_panel.add(pos_box);
				pos_panel.add(case_box);
				pos_panel.add(gender_box);
				pos_panel.add(number_box);
				pos_panel.add(new JLabel());
			}
			else if(value0.equals("other"))
			{
				pos_panel.add(pos_box);
				pos_panel.add(type_box);
				pos_panel.add(new JLabel());
				pos_panel.add(new JLabel());
				pos_panel.add(new JLabel());
			}
			else if(value0.equals("article"))
			{
				pos_panel.add(pos_box);
				pos_panel.add(function_box);
				pos_panel.add(case_box);
				pos_panel.add(gender_box);
				if(value1.equals("indefinite"))
				{
					pos_panel.add(number_singular_box);
				}
				else
				{
					pos_panel.add(number_box);
				}
			}
			else if(value0.equals("pronoun"))
			{
				pos_panel.add(pos_box);
				pos_panel.add(pronoun_mode_box);
				if(value1.equals("inflectionless"))
				{
					pos_panel.add(new JLabel());
					pos_panel.add(new JLabel());
					pos_panel.add(new JLabel());
				}
				else
				{
					pos_panel.add(gender_box);
					pos_panel.add(number_box);
					pos_panel.add(case_box);
				}
			}
			else if(value0.equals("verb"))
			{
				pos_panel.add(pos_box);
				pos_panel.add(verb_mode_box);
				if(value1.equals("--"))
				{
					pos_panel.add(voice_box);
					pos_panel.add(number_box);
					pos_panel.add(tense_box);
				}
				else
				{
					if(value1.equals("infinitive"))
					{
						pos_panel.add(voice_box);
					}
					else
					{
						pos_panel.add(new JLabel());
					}
					pos_panel.add(new JLabel());
					pos_panel.add(new JLabel());
				}
			}
			//update the values in the combo boxes
			if(pos_panel.getComponent(0) instanceof JComboBox)
				((JComboBox)pos_panel.getComponent(0)).setSelectedItem(value0);
			if(pos_panel.getComponent(1) instanceof JComboBox)
				((JComboBox)pos_panel.getComponent(1)).setSelectedItem(value1);
			if(pos_panel.getComponent(2) instanceof JComboBox)
				((JComboBox)pos_panel.getComponent(2)).setSelectedItem(value2);
			if(pos_panel.getComponent(3) instanceof JComboBox)
				((JComboBox)pos_panel.getComponent(3)).setSelectedItem(value3);
			if(pos_panel.getComponent(4) instanceof JComboBox)
				((JComboBox)pos_panel.getComponent(4)).setSelectedItem(value4);
			pos_panel.setVisible(false);
			pos_panel.setVisible(true);
		}
		
		protected JComboBox pos_box;
		protected JComboBox case_box;
		protected JComboBox gender_box;
		protected JComboBox function_box;
		protected JComboBox pronoun_mode_box;
		protected JComboBox verb_mode_box;
		protected JComboBox number_box;
		protected JComboBox number_singular_box;
		protected JComboBox tense_box;
		protected JComboBox voice_box;
		protected JComboBox type_box;
		protected JPanel pos_panel;
		protected JScrollPane scroll;
		protected JTextArea text_area;
	    protected boolean use_high_detail_tag;
	    private String[] values;
	    protected JButton previous;
	    protected JButton next;
	    protected JLabel label;
		
	}

    private Proposer proposer;
    private boolean extended_tag;
    private String[] sentences;
    private int[] startings;
    private int[] endings;
    private int current_sentence;
    private String[] categories;
    private String[] words;
    private Category_filling_panel panel;
    public static String file_separator;
    
}
