package gui.active_learning_tool;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.event.ChangeListener;

public class Active_learning_tool_choices_panel extends JPanel
{

	public Active_learning_tool_choices_panel(Active_learning_tool_gui_manager gui_manager)
	{
		manager = gui_manager;
		setPreferredSize(new Dimension(200, 250));
		setBackground(new Color(239, 239, 239));

		//the cancel button
		cancel = new JButton("Cancel");
		cancel.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent event)
			{
				manager.cancel_pressed();
			}
		});
		
		//the void between the buttons
		middle_void = new JLabel(" ");
		middle_void.setPreferredSize(new Dimension(159, 10));
		
		//the back button
		back = new JButton("< Back");
		back.setVisible(false);
		back.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent event)
			{
				manager.back_pressed();
			}
		});
		
		//the next button
		next = new JButton("Next >");
		next.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent event)
			{
				manager.next_pressed();
			}
		});
		
		//the current panel
		current_panel = new Starting_choice_panel(manager, true);
		
		//gluing the parts together
		add(current_panel);
		add(cancel);
		add(middle_void);
		add(back);
		add(next);
	}
	
	public void show_back_button()
	{
		middle_void.setPreferredSize(new Dimension(80, 10));
		back.setVisible(true);
	}
	
	public void hide_back_button()
	{
		middle_void.setPreferredSize(new Dimension(158, 10));
		back.setVisible(false);
	}
	
	public void change_panel(JPanel panel)
	{
		removeAll();
		current_panel = panel;
		add(current_panel);
		add(cancel);
		add(middle_void);
		add(back);
		add(next);
		setVisible(false);
		setVisible(true);
	}
	
	//the new or old train set choice panel
	public static class Starting_choice_panel extends JPanel
	{
		
		public Starting_choice_panel(Active_learning_tool_gui_manager manager, boolean create_new)
		{
			setBackground(new Color(210, 220, 240));
			setPreferredSize(new Dimension(310, 160));
			setBorder(BorderFactory.createBevelBorder(0));
			
			JLabel label = new JLabel("");
			label.setPreferredSize(new Dimension(290, 4));
			
			add(label);
			add(new JScrollPane(new First_choices_panel(manager, create_new)));
			
		}
		
		//the first two choices
		public class First_choices_panel extends JPanel
		{
			
			public First_choices_panel(final Active_learning_tool_gui_manager manager,
					boolean create_new)
			{
				setPreferredSize(new Dimension(290, 65));
				setBackground(new Color(255, 255, 255));
				
				//the create_new_train_set choice
				final JPanel create_new_train_set = new JPanel();
				create_new_train_set.setPreferredSize(new Dimension(280, 25));
				if(create_new)
				{
					create_new_train_set.setBackground(new Color(230, 230, 250));
				}
				else
				{
					create_new_train_set.setBackground(new Color(255, 255, 255));
				}
				create_new_train_set.add(new JLabel("Create new active learning dataset"));
				
				//the continue_older_train_set choice
				final JPanel continue_older_train_set = new JPanel();
				continue_older_train_set.setPreferredSize(new Dimension(280, 25));
				if(!create_new)
				{
					continue_older_train_set.setBackground(new Color(230, 230, 250));
				}
				else
				{
					continue_older_train_set.setBackground(new Color(255, 255, 255));
				}
				continue_older_train_set.add(new JLabel("Extend existing active learning dataset"));
				
				//the mouse listeners
				create_new_train_set.addMouseListener(new MouseAdapter()
				{
					public void mouseClicked(MouseEvent e)
					{
						create_new_train_set.setBackground(new Color(230, 230, 250));
						continue_older_train_set.setBackground(new Color(255, 255, 255));
						manager.create_new_train_set_selected();
					}
				});
				continue_older_train_set.addMouseListener(new MouseAdapter()
				{
					public void mouseClicked(MouseEvent e)
					{
						continue_older_train_set.setBackground(new Color(230, 230, 250));
						create_new_train_set.setBackground(new Color(255, 255, 255));
						manager.continue_older_train_set_selected();
					}
				});
				
				add(create_new_train_set);
				add(continue_older_train_set);
				
			}
			
		}
		
	}
	
	//the tagset choice panel
	public static class Tagset_choice_panel extends JPanel
	{
		
		public Tagset_choice_panel(Active_learning_tool_gui_manager manager, boolean basic_tagset)
		{

			setBackground(new Color(210, 220, 240));
			setPreferredSize(new Dimension(310, 160));
			setBorder(BorderFactory.createBevelBorder(0));
			setVisible(true);
			
			JLabel label = new JLabel("");
			label.setPreferredSize(new Dimension(290, 4));
			
			add(label);
			
			add(new JScrollPane(new Tagset_choices_panel(manager, basic_tagset)));
			
		}
		
		//the tagset choices
		public class Tagset_choices_panel extends JPanel
		{
			
			public Tagset_choices_panel(final Active_learning_tool_gui_manager manager,
					boolean basic_tagset)
			{
				setPreferredSize(new Dimension(290, 65));
				setBackground(new Color(255, 255, 255));
				
				final JPanel basic = new JPanel();
				basic.setPreferredSize(new Dimension(280, 25));
				if(basic_tagset)
				{
					basic.setBackground(new Color(230, 230, 250));
				}
				else
				{
					basic.setBackground(new Color(255, 255, 255));
				}
				basic.add(new JLabel("Basic Tagset"));
				
				final JPanel extended = new JPanel();
				extended.setPreferredSize(new Dimension(280, 25));
				if(!basic_tagset)
				{
					extended.setBackground(new Color(230, 230, 250));
				}
				else
				{
					extended.setBackground(new Color(255, 255, 255));
				}
				extended.add(new JLabel("Extented Tagset"));
				
				//the mouse listeners
				basic.addMouseListener(new MouseAdapter(){
					public void mouseClicked(MouseEvent e)
					{
						basic.setBackground(new Color(230, 230, 250));
						extended.setBackground(new Color(255, 255, 255));
						manager.basic_tagset_selected();
					}
				});
				extended.addMouseListener(new MouseAdapter(){
					public void mouseClicked(MouseEvent e)
					{
						extended.setBackground(new Color(230, 230, 250));
						basic.setBackground(new Color(255, 255, 255));
						manager.extended_tagset_selected();
					}
				});
				
				add(basic);
				add(extended);
				
			}
		}
	}
	
	//the folder choice panel
	public static class Folder_choice_panel extends JPanel
	{
		
		public Folder_choice_panel(final Active_learning_tool_gui_manager manager,
				String texts_path_in, String auxiliary_path_in)
		{
			setBackground(new Color(210, 220, 240));
			setPreferredSize(new Dimension(310, 160));
			setBorder(BorderFactory.createBevelBorder(0));
			setVisible(true);
			
			JLabel text_folder = new JLabel("Text Pool Folder:");
			text_folder.setPreferredSize(new Dimension(200, 10));
			
			texts_path = new JTextArea(2, 27);
			texts_path.setText(texts_path_in);
			texts_path.setFocusable(false);
			
			JButton texts_chooser = new JButton("Browse");
			texts_chooser.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent event)
				{
					JFileChooser file_chooser = new JFileChooser();
					file_chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
					if(file_chooser.showDialog(null, "Text Pool Folder") == JFileChooser.APPROVE_OPTION)
					{
						if(file_chooser.getSelectedFile().getAbsolutePath() != null)
						{
							if(manager.texts_path_changed(
									file_chooser.getSelectedFile().getAbsolutePath()))
							{
								texts_path.setText(" " + file_chooser.getSelectedFile().getName());
							}
						}
					}
				}
			});
			
			JLabel auxiliary_folder = new JLabel("Dataset Folder:");
			auxiliary_folder.setPreferredSize(new Dimension(200, 13));
			
			auxiliary_path = new JTextArea(2, 27);
			auxiliary_path.setText(auxiliary_path_in);
			auxiliary_path.setFocusable(false);

			JButton auxiliary_chooser = new JButton("Browse");
			auxiliary_chooser.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent event)
				{
					JFileChooser file_chooser = new JFileChooser();
					file_chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
					if(file_chooser.showDialog(null, "Dataset Folder") == JFileChooser.APPROVE_OPTION)
					{
						if(file_chooser.getSelectedFile().getAbsolutePath() != null)
						{
							if(manager.auxiliary_path_changed(
									file_chooser.getSelectedFile().getAbsolutePath()))
							{
								auxiliary_path.setText(" " + file_chooser.getSelectedFile().getName());
							}
						}
					}
				}
			});
			add(text_folder);
			add(texts_chooser);
			add(new JScrollPane(texts_path));
			add(auxiliary_folder);
			add(auxiliary_chooser);
			add(new JScrollPane(auxiliary_path));
		}
		
		public final JTextArea texts_path;
		public final JTextArea auxiliary_path;
		
	}
	
	//the folder continue choice panel
	public static class Folder_continue_choice_panel extends JPanel
	{
		
		public Folder_continue_choice_panel(
				final Active_learning_tool_gui_manager manager, String auxiliary_path_in)
		{
			setBackground(new Color(210, 220, 240));
			setPreferredSize(new Dimension(310, 160));
			setBorder(BorderFactory.createBevelBorder(0));
			setVisible(true);
			
			JLabel auxiliary_folder = new JLabel("Dataset Folder:");
			auxiliary_folder.setPreferredSize(new Dimension(200, 13));
			
			auxiliary_path = new JTextArea(2, 27);
			auxiliary_path.setText(auxiliary_path_in);
			auxiliary_path.setFocusable(false);

			JButton auxiliary_chooser = new JButton("Browse");
			auxiliary_chooser.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent event)
				{
					JFileChooser file_chooser = new JFileChooser();
					file_chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
					if(file_chooser.showDialog(null, "Dataset Folder") == JFileChooser.APPROVE_OPTION)
					{
						if(file_chooser.getSelectedFile().getAbsolutePath() != null)
						{
							if(manager.old_auxiliary_path_changed(
									file_chooser.getSelectedFile().getAbsolutePath()))
							{
								auxiliary_path.setText(" " + file_chooser.getSelectedFile().getName());
							}
						}
					}
				}
			});

			
			JLabel label = new JLabel("");
			label.setPreferredSize(new Dimension(290, 4));
			
			add(label);
			add(auxiliary_folder);
			add(auxiliary_chooser);
			add(new JScrollPane(auxiliary_path));
		}
		public final JTextArea auxiliary_path;
		
	}
	
	private Active_learning_tool_gui_manager manager;
	protected JButton cancel;
	protected JButton back;
	protected JButton next;
	protected JLabel middle_void;
	protected JPanel current_panel;
	
}
