package gui.active_learning_tool;

import javax.swing.*;
import auxiliary_folder_handling.*;
import java.io.*;

public class Active_learning_tool_gui_manager
{

	public Active_learning_tool_gui_manager()
	{
		frame = new Active_learning_tool_frame(this);
		file_separator = System.getProperty("file.separator");
		file_separator = (file_separator.equals("\\"))?"\\\\":file_separator;
		new_train_set = true;
		entropy_plus_diversity = false;
		basic_tagset = true;
		gain_ratio = true;
		k = 1;
		overlap = true;
		texts_path = "";
		auxiliary_path = "";
		old_auxiliary_path = "";
	}
	
	//shows the user interface
	public void init()
	{
		frame.setVisible(true);
	}
	
	//invoked when the cancel button is pressed
	public void cancel_pressed()
	{
		if(JOptionPane.OK_OPTION == JOptionPane.showConfirmDialog(null, "Are you sure you want to quit?"))
		{
			frame.dispose();
		}
	}
	
	//invoked when the back button is pressed
	public void back_pressed()
	{
		if(frame.panel.current_panel
				instanceof Active_learning_tool_choices_panel.Tagset_choice_panel)
		{
			frame.panel.change_panel(new 
					Active_learning_tool_choices_panel.Starting_choice_panel(this, new_train_set));
			frame.panel.hide_back_button();
		}
		else if(frame.panel.current_panel
				instanceof Active_learning_tool_choices_panel.Folder_choice_panel)
		{
			frame.panel.change_panel(new 
					Active_learning_tool_choices_panel.Tagset_choice_panel(this, basic_tagset));
			frame.panel.next.setText("Next >");
		}
		else if(frame.panel.current_panel
				instanceof Active_learning_tool_choices_panel.Folder_continue_choice_panel)
		{
			frame.panel.change_panel(new 
					Active_learning_tool_choices_panel.Starting_choice_panel(this, new_train_set));
			frame.panel.next.setText("Next >");
		}
	}
	
	//invoked when the next button is pressed
	public void next_pressed()
	{
		boolean changed = false;
		if(file_separator.equals("\\"))
		{
			file_separator = "\\\\";
			changed = true;
		}
		if(frame.panel.current_panel
				instanceof Active_learning_tool_choices_panel.Starting_choice_panel)
		{
			if(new_train_set)
			{
				frame.panel.change_panel(new 
						Active_learning_tool_choices_panel.Tagset_choice_panel(this, basic_tagset));
				frame.panel.show_back_button();
			}
			else
			{
				frame.panel.change_panel(new 
					Active_learning_tool_choices_panel.Folder_continue_choice_panel(
							this, " " +
							old_auxiliary_path.split(file_separator)
							[old_auxiliary_path.split(file_separator).length-1]));
				frame.panel.show_back_button();
				frame.panel.next.setText("Finish ");
			}
		}
		else if(frame.panel.current_panel
				instanceof Active_learning_tool_choices_panel.Tagset_choice_panel)
		{
			frame.panel.change_panel(new 
					Active_learning_tool_choices_panel.Folder_choice_panel(
							this, " " + texts_path.split(file_separator)
							[texts_path.split(file_separator).length-1],
							" " + auxiliary_path.split(file_separator)
							[auxiliary_path.split(file_separator).length-1]));
			frame.panel.next.setText("Finish ");
		}
		else if(frame.panel.current_panel
				instanceof Active_learning_tool_choices_panel.Folder_choice_panel ||
				frame.panel.current_panel
				instanceof Active_learning_tool_choices_panel.Folder_continue_choice_panel)
		{
			finish_pressed();
		}
		if(changed)
		{
			file_separator = "\\";
		}
	}
	
	//invoked when the creation of a new train set is selected
	public void create_new_train_set_selected()
	{
		new_train_set = true;
	}
	
	//invoked when the continuance of an old train set is selected
	public void continue_older_train_set_selected()
	{
		new_train_set = false;
	}
	
	//invoked when the entropy measure is selected
	public void entropy_selected()
	{
		entropy_plus_diversity = false;
	}
	
	//invoked when the entropy_plus_diversity measure is selected
	public void entropy_plus_diversity_selected()
	{
		entropy_plus_diversity = true;
	}
	
	//invoked when the basic_tagset is selected
	public void basic_tagset_selected()
	{
		basic_tagset = true;
	}
	
	//invoked when the extended_tagset is selected
	public void extended_tagset_selected()
	{
		basic_tagset = false;
	}
	
	//invoked when the gain_ratio button is pressed
	public void gain_ratio_pressed()
	{
		gain_ratio = !gain_ratio;
	}
	
	//invoked when the overlap button is pressed
	public void overlap_pressed()
	{
		overlap = !overlap;
	}
	
	//invoked when the mvdm button is pressed
	public void mvdm_pressed()
	{
		overlap = !overlap;
	}
	
	//invoked when k changes
	public void k_changed(int k_in)
	{
		k = k_in;
	}
	
	//invoked when the path of the texts folder changes
	public boolean texts_path_changed(String texts_path_in)
	{
		//check if all the files contained in the given folder are text files
		try
		{
			File[] subfiles = new File(texts_path_in).listFiles();
			for(int i=0; i<subfiles.length; ++i)
			{
				if(!subfiles[i].isFile())
				{
					throw new Exception();
				}
				if(!subfiles[i].getName().substring(
						subfiles[i].getName().length()-4,
						subfiles[i].getName().length()).equalsIgnoreCase(".txt"))
				{
					throw new Exception();
				}
				
			}
			texts_path = texts_path_in;
			return true;
		}
		catch(Exception e)
		{
			JOptionPane.showMessageDialog(null,
					"The selected folder does not contain text files only!");
		}
		return false;
	}
	
	//invoked when the path of the auxiliary folder changes
	public boolean auxiliary_path_changed(String auxiliary_path_in)
	{
		//check if the given folder is empty
		try
		{
			File[] subfiles = new File(auxiliary_path_in).listFiles();
			if(subfiles.length != 0)
			{
				throw new Exception();
			}
			auxiliary_path = auxiliary_path_in;
			return true;
		}
		catch(Exception e)
		{
			JOptionPane.showMessageDialog(null,
					"The selected folder is not empty!");
		}
		return false;
	}
	
	//invoked when the old_auxiliary_path changes
	public boolean old_auxiliary_path_changed(String auxiliary_path_in)
	{
		//see that the parameters file exists
		try
		{
			File[] files = new File(auxiliary_path_in).listFiles();
			for(int i=0; i<files.length; ++i)
			{
				if(files[i].getName().equals("parameters.txt"))
				{
					old_auxiliary_path = auxiliary_path_in;
					return true;
				}
			}
		}
		catch(Exception e)
		{
			e.printStackTrace();
			return false;
		}
		JOptionPane.showMessageDialog(null, "The selected folder is not an dataset folder.");
		return false;
	}
	
	//invoked when the finish button is pressed
	public void finish_pressed()
	{
		//if the finish button is in the new train set creation
		if(frame.panel.current_panel
				instanceof Active_learning_tool_choices_panel.Folder_choice_panel)
		{
			//if info is missing
			if(((Active_learning_tool_choices_panel.Folder_choice_panel)
					frame.panel.current_panel).texts_path.getText().equals(" ") ||
					((Active_learning_tool_choices_panel.Folder_choice_panel)
							frame.panel.current_panel).auxiliary_path.getText().equals(" "))
			{
				JOptionPane.showMessageDialog(null, "Both folder fields must be completed.");
			}
			//else
			else
			{
				finish();
			}
		}
		//else if it is on the old train set
		else if(frame.panel.current_panel
				instanceof Active_learning_tool_choices_panel.Folder_continue_choice_panel)
		{
			//if info is missing
			if(((Active_learning_tool_choices_panel.Folder_continue_choice_panel)
							frame.panel.current_panel).auxiliary_path.getText().equals(" "))
			{
				JOptionPane.showMessageDialog(null, "The Dataset Folder field must be completed.");
			}
			//else
			else
			{
				frame.dispose();
				start_proposing(old_auxiliary_path);
			}
		}
	}
	
	//invoked when all the info has been filled and finish is pressed when creating a new train set
	private void finish()
	{
		frame.dispose();
		//create the auxiliary folder
		Auxiliary_creator creator = new Auxiliary_creator();
		creator.create_auxiliary(this, entropy_plus_diversity, basic_tagset, gain_ratio, k, overlap,
				texts_path, auxiliary_path,
				new Active_learning_tool_loading_bar(
						"Creating Dataset Folder").init());
		creator.execute();
	}
	
	//invoked when the auxiliary folder is ready
	public void start_proposing(String auxiliary)
	{
		new Proposer(auxiliary);
	}
	
	private Active_learning_tool_frame frame;
	private boolean new_train_set;
	private boolean entropy_plus_diversity = false;
	private boolean basic_tagset;
	private boolean gain_ratio = true;
	private int k = 1;
	private boolean overlap = true;
	private String texts_path;
	private String auxiliary_path;
	private String old_auxiliary_path;
	public static String file_separator;
	
}
