package gui.annotation_tool;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;

public class Annotation_tool_panel extends JPanel
{

	//the sole constructor where all components of the panel are initialized
	public Annotation_tool_panel(Annotation_tool_gui_manager gui_manager)
	{
		manager = gui_manager;
		//the pos combo box
		pos_box = new JComboBox();
		pos_box.addItem("--");
		pos_box.addItem("article");
		pos_box.addItem("verb");
		pos_box.addItem("punctuation");
		pos_box.addItem("adjective");
		pos_box.addItem("adverb");
		pos_box.addItem("conjunction");
		pos_box.addItem("noun");
		pos_box.addItem("numeral");
		pos_box.addItem("particle");
		pos_box.addItem("preposition");
		pos_box.addItem("pronoun");
		pos_box.addItem("other");
		pos_box.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent event)
			{
				manager.tag_changed((String)pos_box.getSelectedItem(),
						pos_panel.getComponentZOrder(pos_box));
			}
		});
		
		//the case combo box
		case_box = new JComboBox();
		case_box.addItem("--");
		case_box.addItem("nominative");
		case_box.addItem("genitive");
		case_box.addItem("accusative");
		case_box.addItem("vocative");
		case_box.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent event)
			{
				manager.tag_changed((String)case_box.getSelectedItem(),
						pos_panel.getComponentZOrder(case_box));
			}
		});
		
		//the gender combo box
		gender_box = new JComboBox();
		gender_box.addItem("--");
		gender_box.addItem("masculine");
		gender_box.addItem("feminine");
		gender_box.addItem("neuter");
		gender_box.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent event)
			{
				manager.tag_changed((String)gender_box.getSelectedItem(),
						pos_panel.getComponentZOrder(gender_box));
			}
		});
		
		//the tense combo box
		tense_box = new JComboBox();
		tense_box.addItem("--");
		tense_box.addItem("present");
		tense_box.addItem("past");
		tense_box.addItem("future");
		tense_box.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent event)
			{
				manager.tag_changed((String)tense_box.getSelectedItem(),
						pos_panel.getComponentZOrder(tense_box));
			}
		});
		
		//the number combo box
		number_box = new JComboBox();
		number_box.addItem("--");
		number_box.addItem("singular");
		number_box.addItem("plural");
		number_box.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent event)
			{
				manager.tag_changed((String)number_box.getSelectedItem(),
						pos_panel.getComponentZOrder(number_box));
			}
		});
		
		//the number singular combo box
		number_singular_box = new JComboBox();
		number_singular_box.addItem("--");
		number_singular_box.addItem("singular");
		number_singular_box.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent event)
			{
				manager.tag_changed((String)number_singular_box.getSelectedItem(),
						pos_panel.getComponentZOrder(number_singular_box));
			}
		});
		
		//the type combo box
		type_box = new JComboBox();
		type_box.addItem("--");
		type_box.addItem("abbreviation");
		type_box.addItem("acronym");
		type_box.addItem("foreign_word");
		type_box.addItem("symbol");
		type_box.addItem("other");
		type_box.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent event)
			{
				manager.tag_changed((String)type_box.getSelectedItem(),
						pos_panel.getComponentZOrder(type_box));
			}
		});
		
		//the function combo box
		function_box = new JComboBox();
		function_box.addItem("--");
		function_box.addItem("definite");
		function_box.addItem("indefinite");
		function_box.addItem("prepositional");
		function_box.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent event)
			{
				manager.tag_changed((String)function_box.getSelectedItem(),
						pos_panel.getComponentZOrder(function_box));
			}
		});
		
		//the pronoun mode combo box
		pronoun_mode_box = new JComboBox();
		pronoun_mode_box.addItem("--");
		pronoun_mode_box.addItem("inflectionless");
		pronoun_mode_box.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent event)
			{
				manager.tag_changed((String)pronoun_mode_box.getSelectedItem(),
						pos_panel.getComponentZOrder(pronoun_mode_box));
			}
		});
		
		//the verb mode combo box
		verb_mode_box = new JComboBox();
		verb_mode_box.addItem("--");
		verb_mode_box.addItem("infinitive");
		verb_mode_box.addItem("participle");
		verb_mode_box.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent event)
			{
				manager.tag_changed((String)verb_mode_box.getSelectedItem(),
						pos_panel.getComponentZOrder(verb_mode_box));
			}
		});
		
		//the voice combo box
		voice_box = new JComboBox();
		voice_box.addItem("--");
		voice_box.addItem("active");
		voice_box.addItem("passive");
		voice_box.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent event)
			{
				manager.tag_changed((String)voice_box.getSelectedItem(),
						pos_panel.getComponentZOrder(voice_box));
			}
		});
		
		//the pos panel
		pos_panel = new JPanel();
		pos_panel.setPreferredSize(new Dimension(535, 30));
		pos_panel.setVisible(true);
		
		//adding components to the pos panel
		GridLayout layout = new GridLayout();
		//set the gaps between the combo boxes
		layout.setHgap(10);
		pos_panel.setLayout(layout);
	    
	    //the left token button
	    left_token = new JButton("<<");
	    left_token.setToolTipText("View previous token");
	    left_token.addActionListener(new ActionListener(){
	    	public void actionPerformed(ActionEvent event)
	    	{
	    		manager.request_for_previous_token();
	    	}
	    });
	    
	    //the right token button
	    right_token = new JButton(">>");
	    right_token.setToolTipText("View next token");
	    right_token.addActionListener(new ActionListener(){
	    	public void actionPerformed(ActionEvent event)
	    	{
	    		manager.request_for_next_token();
	    	}
	    });
	    
	    //the token bar
	    token_bar = new JTextField();
	    token_bar.setEditable(false);
	    token_bar.setFont(new Font(Font.DIALOG, Font.HANGING_BASELINE, 13));
        token_bar.setText("Token Bar");
        token_bar.setPreferredSize(new Dimension(428, 20));
		
		//the text area - where the given text appears as it is
		text_area = new JTextArea();
	    text_area.setFocusable(false);
	    text_area.addCaretListener(new CaretListener()
	    {
            public void caretUpdate(CaretEvent event)
            {
            	//the current location of the cursor
                manager.cursor_changed(event.getDot());
            }
        });
	    
		//the scroll
		scroll = new JScrollPane();
		scroll.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
		scroll.setPreferredSize(new Dimension(535, 400));
	    scroll.setViewportView(text_area);
	    
	    //the left document button
	    left_document = new JButton("<<");
	    left_document.setToolTipText("View previous document");
	    left_document.addActionListener(new ActionListener(){
	    	public void actionPerformed(ActionEvent event)
	    	{
	    		manager.request_for_previous_document();
	    	}
	    });
	    
	    //the right document button
	    right_document = new JButton(">>");
	    right_document.setToolTipText("View next document");
	    right_document.addActionListener(new ActionListener(){
	    	public void actionPerformed(ActionEvent event)
	    	{
	    		manager.request_for_next_document();
	    	}
	    });
	    
	    //the status bar
	    document_bar = new JTextField();
	    document_bar.setEditable(false);
	    document_bar.setFont(new Font(Font.DIALOG, Font.HANGING_BASELINE, 13));
	    document_bar.setText("Status Bar");
	    document_bar.setPreferredSize(new Dimension(428, 20));
	    
	    //the progress bar
	    progress_bar = new JProgressBar();
	    progress_bar.setPreferredSize(new Dimension(535, 30));
	    
        //adding the components
        add(pos_panel);
	    add(left_token);
	    add(token_bar);
	    add(right_token);
	    add(scroll);
	    add(left_document);
	    add(document_bar);
	    add(right_document);
	    add(progress_bar);
		
	    //high detail by default
	    use_high_detail_tag = true;
	}
	
	//sets the detail mode for the tags
	protected void use_high_detail_tag(boolean high_detail, String v0, String v1,
			String v2, String v3, String v4)
	{
		use_high_detail_tag = high_detail;
		show_combo_boxes_for_values(v0, v1, v2, v3, v4);
	}
	
	//according to the part of speech main tag the secondary tags should change properly
	protected void show_combo_boxes_for_values(String value0, String value1, String value2,
			String value3, String value4)
	{
		//clear the pos_panel
		pos_panel.removeAll();
		
		//if we use low detail we only keep the main tag
		if(!use_high_detail_tag)
		{
			pos_panel.add(pos_box);
			pos_panel.add(new JLabel());
			pos_panel.add(new JLabel());
			pos_panel.add(new JLabel());
			pos_panel.add(new JLabel());
		}
		//else we add the corresponding secondary tags
		else if(value0.equals("--") || value0.equals("adverb") || value0.equals("conjunction")
				|| value0.equals("numeral") || value0.equals("particle") ||
				value0.equals("preposition") || value0.equals("punctuation"))
		{
			pos_panel.add(pos_box);
			pos_panel.add(new JLabel());
			pos_panel.add(new JLabel());
			pos_panel.add(new JLabel());
			pos_panel.add(new JLabel());
		}
		else if(value0.equals("adjective") || value0.equals("noun"))
		{
			pos_panel.add(pos_box);
			pos_panel.add(case_box);
			pos_panel.add(gender_box);
			pos_panel.add(number_box);
			pos_panel.add(new JLabel());
		}
		else if(value0.equals("other"))
		{
			pos_panel.add(pos_box);
			pos_panel.add(type_box);
			pos_panel.add(new JLabel());
			pos_panel.add(new JLabel());
			pos_panel.add(new JLabel());
		}
		else if(value0.equals("article"))
		{
			pos_panel.add(pos_box);
			pos_panel.add(function_box);
			pos_panel.add(case_box);
			pos_panel.add(gender_box);
			if(value1.equals("indefinite"))
			{
				pos_panel.add(number_singular_box);
			}
			else
			{
				pos_panel.add(number_box);
			}
		}
		else if(value0.equals("pronoun"))
		{
			pos_panel.add(pos_box);
			pos_panel.add(pronoun_mode_box);
			if(value1.equals("inflectionless"))
			{
				pos_panel.add(new JLabel());
				pos_panel.add(new JLabel());
				pos_panel.add(new JLabel());
			}
			else
			{
				pos_panel.add(case_box);
				pos_panel.add(gender_box);
				pos_panel.add(number_box);
			}
		}
		else if(value0.equals("verb"))
		{
			pos_panel.add(pos_box);
			pos_panel.add(verb_mode_box);
			if(value1.equals("--"))
			{
				pos_panel.add(voice_box);
				pos_panel.add(number_box);
				pos_panel.add(tense_box);
			}
			else
			{
				if(value1.equals("infinitive"))
				{
					pos_panel.add(voice_box);
				}
				else
				{
					pos_panel.add(new JLabel());
				}
				pos_panel.add(new JLabel());
				pos_panel.add(new JLabel());
			}
		}
		//update the values in the combo boxes
		if(pos_panel.getComponent(0) instanceof JComboBox)
			((JComboBox)pos_panel.getComponent(0)).setSelectedItem(value0);
		if(pos_panel.getComponent(1) instanceof JComboBox)
			((JComboBox)pos_panel.getComponent(1)).setSelectedItem(value1);
		if(pos_panel.getComponent(2) instanceof JComboBox)
			((JComboBox)pos_panel.getComponent(2)).setSelectedItem(value2);
		if(pos_panel.getComponent(3) instanceof JComboBox)
			((JComboBox)pos_panel.getComponent(3)).setSelectedItem(value3);
		if(pos_panel.getComponent(4) instanceof JComboBox)
			((JComboBox)pos_panel.getComponent(4)).setSelectedItem(value4);
		pos_panel.setVisible(false);
		pos_panel.setVisible(true);
	}
	
	protected JComboBox pos_box;
	protected JComboBox case_box;
	protected JComboBox gender_box;
	protected JComboBox function_box;
	protected JComboBox pronoun_mode_box;
	protected JComboBox verb_mode_box;
	protected JComboBox number_box;
	protected JComboBox number_singular_box;
	protected JComboBox tense_box;
	protected JComboBox voice_box;
	protected JComboBox type_box;
	protected JPanel pos_panel;
	protected JScrollPane scroll;
	protected JTextArea text_area;
	protected JTextField document_bar;
	protected JProgressBar progress_bar;
    protected JButton left_document;
    protected JButton right_document;
	protected JTextField token_bar;
    protected JButton left_token;
    protected JButton right_token;
    protected boolean use_high_detail_tag;
    protected final Annotation_tool_gui_manager manager;
	
}
