package main;

import gui.active_learning_tool.Active_learning_tool_gui_manager;
import gui.annotation_tool.Annotation_tool_gui_manager;
import java.awt.*;
import javax.swing.*;

public class Main
{

	public static void main(String[] args)
	{
		file_separator = System.getProperty("file.separator");
		file_separator = (file_separator.equals("\\"))?"\\\\":file_separator;
		new Main().init();
	}
	
	public void init()
	{
		panel = new Main_panel(new Non_panel());
		frame = new Startup_frame(this, panel);
		frame.init();
	}
	
	public void mouse_clicked()
	{
		if(panel.panel instanceof Ann_panel)
		{
			Annotation_tool_gui_manager manager = new Annotation_tool_gui_manager();
			manager.init();
			frame.dispose();
		}
		else if(panel.panel instanceof Cft_panel)
		{
			Active_learning_tool_gui_manager manager = new Active_learning_tool_gui_manager();
			manager.init();
			frame.dispose();
		}
	}
	
	public void mouse_moved(int x, int y, int fx, int fy)
	{
		PopupFactory factory = PopupFactory.getSharedInstance();
		if(x >= 65 && x <= 100 && y >= 75 && y <= 110)
		{
			if(!(panel.panel instanceof Ann_panel))
			{
				panel.change_panel(new Ann_panel());
			}
		}
		else if(x >= 65 && x <= 100 && y >= 143 && y <= 178)
		{
			if(!(panel.panel instanceof Cft_panel))
			{
				panel.change_panel(new Cft_panel());
			}
		}
		else
		{
			if(!(panel.panel instanceof Non_panel))
			{
				panel.change_panel(new Non_panel());
			}
		}
	}
	
	public class Non_panel extends JPanel
	{
		
		public Non_panel()
		{
			setBackground(new Color(239, 239, 239));
			add(new JLabel(new ImageIcon("." + file_separator + "pics" + file_separator + "both_off.JPG")));
		}
		
	}
	
	public class Ann_panel extends JPanel
	{
		
		public Ann_panel()
		{
			setBackground(new Color(239, 239, 239));
			add(new JLabel(new ImageIcon("." + file_separator + "pics" + file_separator + "up.JPG")));
		}
		
	}
	
	public class Cft_panel extends JPanel
	{
		
		public Cft_panel()
		{
			setBackground(new Color(239, 239, 239));
			add(new JLabel(new ImageIcon("." + file_separator + "pics" + file_separator + "down.JPG")));
		}
		
	}
	
	public class Main_panel extends JPanel
	{
		
		public Main_panel(JPanel p)
		{
			panel = p;
			setBackground(new Color(239, 239, 239));
			add(p);
			setVisible(true);
		}
		
		public void change_panel(JPanel p)
		{
			panel = p;
			removeAll();
			add(p);
			setVisible(false);
			setVisible(true);
		}
		
		public JPanel panel;
		
	}
	
	private Startup_frame frame;
	private Main_panel panel;
	public static String file_separator;
}
