package main;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.imageio.*;
import javax.swing.*;
import java.io.*;
import java.net.*;

public class Startup_frame extends JFrame
{

	public Startup_frame(Main m, JPanel p)
	{
		//the title
		super("AUEB's Greek Part-Of-Speech Tagger");
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setResizable(false);
		setSize(435, 240);
		setBackground(new Color(0, 0, 0));
		setLocationRelativeTo(null);
		file_separator = System.getProperty("file.separator");
		file_separator = (file_separator.equals("\\"))?"\\\\":file_separator;
		panel = p;
		manager = m;
		setContentPane(panel);
		//change the frame icon
		BufferedImage image = null;
        try
        {
        	image = ImageIO.read(new URL("file:"+new File("pics" + file_separator + "icon.JPG").getAbsolutePath()));
        }
        catch (IOException e)
        {
            e.printStackTrace();
        }
        setIconImage(image);
        final JFrame frame = this;
		addMouseMotionListener(new MouseMotionListener()
		{
			
			public void mouseMoved(MouseEvent e)
			{
				manager.mouse_moved(e.getX(), e.getY(), frame.getX(), frame.getY());
			}
			
			public void mouseDragged(MouseEvent e){}
			
		});
		
		addMouseListener(new MouseAdapter()
		{
			public void mouseClicked(MouseEvent e)
			{
				manager.mouse_clicked();
			}
		});
		
	}
	
	public void init()
	{
		setVisible(true);
	}
	
	private JPanel panel;
	private Main manager;
	public static String file_separator;
}
